package com.bjlt.spider.business.Jinair.service.impl;


import com.alibaba.fastjson.JSON;
import com.bjlt.spider.airasia.dao.IpDao;
import com.bjlt.spider.business.Jinair.service.JinairService;
import com.bjlt.spider.business.common.dao.BigAppIpDao;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.jinair.dao.JinairDao;
import com.bjlt.spider.util.MethodType;
import com.bjlt.spider.util.RespEntity;
import com.luyn.core.StringUtil;
import com.luyn.http.proxy.HttpProxy;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Slf4j
@Service
public class JinairServiceImpl implements JinairService{

    @Autowired
    Config config;

    @Autowired
    BigAppIpDao ipDao;

    @Autowired
    JinairDao jinairDao;

    @Override
    public RespEntity search(SearchRequestEntity searchRequestEntity) {

        if(searchRequestEntity.getUuid() == null || searchRequestEntity.getUuid().equals("")){
            log.error("请求参数不正确:"+ JSON.toJSONString(searchRequestEntity));
            return RespEntity.error("请求参数不正确");
        }
        long statTime = System.currentTimeMillis();
        // 进行 非空验证
        if (StringUtil.hasBlank(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity()) || searchRequestEntity.getAdultNum() <= 0) {
            System.out.println("请求参数不正确:"+JSON.toJSONString(searchRequestEntity));
            log.error("请求参数不正确:"+JSON.toJSONString(searchRequestEntity));
            return RespEntity.error("请求参数不正确");
        }
        if (StringUtil.isBlank(searchRequestEntity.getCurrency())) {
            searchRequestEntity.setCurrency("CNY");
        }
        HttpProxy proxy = null;
        if(config != null && config.isProxy()){
            proxy = ipDao.getIp("Lionair_WebOrMobile", MethodType.SEARCH.getTypeName());
            if(proxy == null || StringUtil.isBlank(proxy.getAddress())){
                log.error("获取ip 失败");
                return  RespEntity.error("获取ip 失败");
            }
        }
        SearchResponseEntity searchResponseEntity = jinairDao.search(searchRequestEntity, proxy);
        searchResponseEntity.setUuid(searchRequestEntity.getUuid());
        return RespEntity.success(searchResponseEntity);
    }
}
