package com.bjlt.spider.business.airasia.controller;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.business.airasia.service.AirasiaBigAppService;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.monitor.utils.CallBackUtils;
import com.bjlt.spider.monitor.utils.SearchStatisticsUtil;
import com.bjlt.spider.util.RespCode;
import com.bjlt.spider.util.RespEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Date;

/**
 * @author: luyanan0718@163.com
 * @create :2018/2/28 12:00
 * @introduce :
 **/
@Slf4j
@Controller
@RequestMapping("/airasia/big/app/")
public class AirasiaBigAppController {


    @Autowired
    Config config;


    @Autowired
    AirasiaBigAppService airasiaBigAppService;


    /**
     * 查询接口
     *
     * @param searchRequestEntity
     * @return
     */
    @PostMapping(value = "/search")
    public void search(@RequestBody SearchRequestEntity searchRequestEntity) {
        System.out.println("请求的参数为---" + JSON.toJSONString(searchRequestEntity));
        Date satrtDate = new Date();


        SearchStatisticsUtil.SearchTotal();//统计请求次数
        log.info("开始亚航的查询-----查询参数为-" + JSON.toJSONString(searchRequestEntity));
        try {
            RespEntity respEntity = airasiaBigAppService.serach2(searchRequestEntity);





//            Date endDate = new Date();
//            createLog(satrtDate, endDate, respEntity, searchRequestEntity);

            if (respEntity.getStatus() == 200) {
                CallBackUtils.callBack(JSON.toJSONString(respEntity), config);
            }

//            return respEntity;
        } catch (Exception e) {
            e.printStackTrace();
//            return RespEntity.error(RespCode.PROGRAM_SPIDERT_ERROR, e);
        }
    }


    /**
     * 查询接口
     *
     * @param searchRequestEntity
     * @return
     */
    @PostMapping(value = "/testsearch")
    @ResponseBody
    public RespEntity testSearch(@RequestBody SearchRequestEntity searchRequestEntity) {
        System.out.println("请求的参数为---" + JSON.toJSONString(searchRequestEntity));
        SearchStatisticsUtil.SearchTotal();//统计请求次数
        log.info("开始亚航的查询-----查询参数为-" + JSON.toJSONString(searchRequestEntity));
        try {
            RespEntity respEntity = airasiaBigAppService.serach(searchRequestEntity);

            log.info("返回的结果为-->{}",JSON.toJSONString(respEntity));


            return respEntity;
        } catch (Exception e) {
            e.printStackTrace();
            return RespEntity.error(RespCode.PROGRAM_SPIDERT_ERROR, e);
        }
    }


}
