package com.bjlt.spider.business.airasia.controller;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.business.airasia.service.AirasiaMobileService;
import com.bjlt.spider.util.RespCode;
import com.bjlt.spider.util.RespEntity;
import com.luyn.core.StringUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author: luyanan0718@163.com
 * @create :2017/11/16 16:16
 * @introduce :  亚航的 mobile端的 查询
 **/

@RequestMapping("/airasiamobile")
@RestController
@Slf4j
public class AirasiaMobileController {

    @Autowired
    AirasiaMobileService airasiaMobileService;

    /**
     * 查询接口
     *
     * @param searchRequestEntity
     * @return
     */
    @PostMapping(value = "/search")
    public RespEntity search(@RequestBody SearchRequestEntity searchRequestEntity) {
        System.out.println("请求的参数为---" + JSON.toJSONString(searchRequestEntity));
        // 检查请求的参数
        if (searchRequestEntity == null || StringUtil.isBlank(searchRequestEntity.getFormCity()) || StringUtil.isBlank(searchRequestEntity.getFromDate()) || StringUtil.isBlank(searchRequestEntity.getToCity()) || searchRequestEntity.getAdultNum() == 0 || StringUtil.isBlank(searchRequestEntity.getAirSource())) {
            return RespEntity.error("请求参数出错");
        }

        log.info("开始亚航的查询-----查询参数为-" + JSON.toJSONString(searchRequestEntity));
        try {
            RespEntity respEntity = airasiaMobileService.search(searchRequestEntity);
            System.out.println("result----" + JSON.toJSONString(respEntity));
            if (respEntity != null) {
                return respEntity;
            }

        } catch (Exception e) {
            e.printStackTrace();
            return RespEntity.error(RespCode.PROGRAM_SPIDERT_ERROR, e);
        }
        return RespEntity.error("未知错误");
    }


}
