package com.bjlt.spider.business.airasia.service.impl;

import com.alibaba.fastjson.JSON;

import com.bjlt.spider.airasia.dao.AiraisaWebDao;
import com.bjlt.spider.airasia.dao.IpDao;
import com.bjlt.spider.airasia.queue.AirasiaSearchCookieQueue;
import com.bjlt.spider.business.common.dao.BigAppIpDao;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.*;
import com.bjlt.spider.business.airasia.service.AirAsiaWebService;
import com.bjlt.spider.entity.addach.BaggageEntity;
import com.bjlt.spider.entity.monitor.MonitorEntity;
import com.bjlt.spider.monitor.utils.SearchStatisticsUtil;
import com.bjlt.spider.util.*;
import com.bjlt.spider.utils.CommonUtils;
import com.bjlt.spider.utils.NewIpDao;
import com.google.common.collect.Lists;

import com.luyn.core.RandomUtil;
import com.luyn.core.RegexUtil;
import com.luyn.core.StringUtil;
import com.luyn.date.DatePattren;
import com.luyn.date.DateUtil;

import com.luyn.http.httpclient.HttpClientDownloader;
import com.luyn.http.okhttp.OkHttpDownLoader;
import com.luyn.http.proxy.HttpProxy;

import com.luyn.http.response.HttpResponse;
import com.luyn.http.utils.CookieUtils;
import com.luyn.io.FileUtil;
import com.luyn.json.JsonUtils;
import com.luyn.log.SysLogger;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.ParseException;
import java.util.*;
import java.util.concurrent.*;

/**
 * auth : luyanan0718@163.com
 * com.bjlt.spider.service.impl
 * CreateTime:2017/10/12-14:14
 * introduce:  AirAsiaAPP 接口层
 *
 * @author Administrator
 */
@Service
@Slf4j
public class AirAsiaWebServiceImpl implements AirAsiaWebService {

    private static final SysLogger logger = SysLogger.getSysLogger(AirAsiaWebServiceImpl.class, true);


    private static String key = "AIRASIA_SEARCH_";

    @Autowired
    BigAppIpDao ipDao;

//    @Autowired
//    NewIpDao  ipDao;

    @Value("${priceFormat}")
    private String priceFormat;


    @Autowired
    AiraisaWebDao airaisaWebDao;


    @Autowired
    AirasiaSearchCookieQueue airasiaSearchCookieQueue;

    @Autowired
    Config config;


    @Autowired
    RedisTemplate redisTemplate;


    @Autowired
    AirasiaSearchCookieQueue airasiaSearchCoookieQueue;

//    @Autowired
//    StringRedisTemplate redisTemplate;


//    private SearchRequestEntity searchRequestEntity;

//    /**
//     * 根据请求参数，采集内容
//     *
//     * @param searchRequestEntity
//     * @return
//     */
//    @Override
//    public RespEntity serach(SearchRequestEntity searchRequestEntity) throws Exception {
//
//        // 拼装访问的url
////        回程
////        https://booking.airasia.com/Flight/Select?o1=IXC&d1=HYD&dd1=2018-02-15&dd2=2018-03-14&r=true&ADT=1&CHD=1&inl=0&s=true&mon=true&cc=INR
//        // 这里默认为false的原因是由于测试方便
//        boolean proxy = false;
//        try {
//            if (searchRequestEntity == null) {
//                return RespEntity.error(RespCode.SEARCH_REQUEST_ERROR);
//            } else if (StringUtil.isBlank(searchRequestEntity.getToCity()) || StringUtil.isBlank(searchRequestEntity.getFormCity()) || StringUtil.isBlank(searchRequestEntity.getFromDate()) && StringUtil.isBlank(searchRequestEntity.getAirSource())) {
//                return RespEntity.error(RespCode.SEARCH_REQUEST_ERROR);
//            }
//            StringBuffer url = new StringBuffer();
//            url.append("https://booking.airasia.com/Flight/Select?o1=" + searchRequestEntity.getFormCity() + "&d1=" + searchRequestEntity.getToCity() + "&dd1=" + searchRequestEntity.getFromDate());
//            if (StringUtil.isNotBlank(searchRequestEntity.getRetDate())) {
//                url.append("&dd2=").append(searchRequestEntity.getRetDate());
//            }
//            url.append("&r=true&ADT=").append(searchRequestEntity.getAdultNum());
//
//            if (StringUtil.isBlank(searchRequestEntity.getCurrency())) {
//                searchRequestEntity.setCurrency("CNY");
//            }
//            url.append("&CHD=").append(searchRequestEntity.getChildNum());
//            url.append("&s=true&mon=true&cc=").append(searchRequestEntity.getCurrency()).append("&c=false");
//            log.info("请求的url地址为" + url.toString());
//            System.out.println(url);
//            Map<String, String> headerMap = new ConcurrentHashMap<>();
//
//
//            String urlContent = "";
//            try {
//                urlContent = URLUtil.UrlSplitTools(url.toString()).getContext();
//            } catch (Exception e) {
//                log.error(url + "解析失败---", e);
//            }
//
//            headerMap.put("accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8");
//            headerMap.put("accept-encoding", "gzip, deflate, br");
//            headerMap.put("accept-language", "zh-CN,zh;q=0.9");
//            headerMap.put("upgrade-insecure-requests", "1");
//            headerMap.put("Cookie", "currencySelect=HKD");
//            headerMap.put("user-agent", "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36");
////
////            //不使用代理ip
////            if (StringUtil.isBlank(isProxy) || isProxy.equals("false")) {
////                proxy = false;
////            } else if (isProxy.equals("true")) {
////                proxy = true;
////            } else {
////                log.error(isProxy + "参数配置错误");
////                return RespEntity.error(RespCode.PROGRAM_CONFIG_ERROR);
////            }
//
//
//            String html = null;
//
//
//            HttpProxy ipEntity = null;
//            if (config != null && config.isProxy()) {
//                ipEntity = ipDao.getIp(IpChannelIdEntity.AK_WEB.getChannelId() + "", MethodType.SEARCH.getTypeName());
//                if (ipEntity == null || StringUtil.isBlank(ipEntity.getAddress())) {
//                    return RespEntity.error("获取到的ip为空");
//
//                }
//            }
//
//////            String cookie = null;
////            // 将ipEntity 转换为proxyEntity 对象
////            HttpProxy proxyPojo = new HttpProxy();
////            if (ipEntity != null && StringUtil.isNotBlank(ipEntity.getAddress())) {
////                proxyPojo.setAddress(ipEntity.getAddress());
////                proxyPojo.setPort(ipEntity.getPort());
//////                cookie = ipEntity.getCookie();
//////                log.info("indexCookie---"+cookie);
////            }
//            // 线程超时设置
//            ExecutorService executorService = Executors.newFixedThreadPool(1);
//            try {
//
//                boolean finalProxy = proxy;
//                HttpProxy finalIpEntity = ipEntity;
//                CompletableFuture<String> future = CompletableFuture.supplyAsync(() -> getContentFromAirAsiaWeb2(url.toString(), headerMap, finalProxy, searchRequestEntity.getAirSource(), finalIpEntity), executorService);
//                html = future.get(1000 * 250, TimeUnit.MILLISECONDS);
//            } catch (Exception e) {
//                RespEntity.error(RespCode.PROGRAM_SPIDERT_ERROR, e);
//                log.error("页面采集失败", e);
//            } finally {
//                executorService.shutdown();
//            }
//            if(ipEntity != null && StringUtil.isNotBlank(ipEntity.getAddress())){
//                ipDao.returnIp(IpChannelIdEntity.AK_WEB.getChannelId() + "", ipEntity.getAddress());
//                log.info("归还ip--{}", ipEntity.getAddress());
//            }
//
//
//
//            if (StringUtil.isNotBlank(html)) {
//                return RespEntity.success(parser(html, searchRequestEntity));
//            }
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            return RespEntity.error(RespCode.PROGRAM_SPIDERT_ERROR, e);
//        }
//        return RespEntity.error(RespCode.PROGRAM_SPIDERT_ERROR, null);
//    }


    public RespEntity getSearchCookie(RedisTemplate redisTemplate, String fromCity, String toCity, String fromDate) {
        Set<String> searchKeysSets = redisTemplate.keys(key + "*");
        if (searchKeysSets != null && searchKeysSets.size() > 0) {
            List<String> searchKeyLists = CommonUtils.toList(searchKeysSets);
            if (searchKeyLists != null && searchKeyLists.size() > 0) {
                String randomKey = searchKeyLists.get(RandomUtil.randomInt(searchKeyLists.size()));


                String result = redisTemplate.opsForValue().get(randomKey).toString();
                if (StringUtil.isNotBlank(result)) {

                    return RespEntity.success(result);
                }


            }


        } else {
            String url = "http://120.78.160.252:32001/airasia/web/randomcookie";
            Map<String, String> froms = new HashMap<>();
            froms.put("fromCity", fromCity);
            froms.put("toCity", toCity);
            froms.put("fromDate", fromDate);
            String resp = HttpClientDownloader.post(url).params(froms).HttpClientexecute().asString();
            if (StringUtil.isNotBlank(resp)) {

                String attachment = JsonUtils.get(resp, "attachment");
                if (StringUtil.isNotBlank(attachment)) {
                    return RespEntity.success(attachment);
                }


            }
        }

        return RespEntity.error("获取失败");

    }


    /**
     * 新版本
     *
     * @param searchRequestEntity
     * @return
     * @throws Exception
     */
    @Override
    public RespEntity serach(SearchRequestEntity searchRequestEntity, MonitorEntity monitorEntity) {

        RespEntity respEntity = null;
//        this.searchRequestEntity = searchRequestEntity;
        System.out.println("请求参数为---" + JSON.toJSONString(searchRequestEntity));
        HttpProxy proxy = null;
        if (config != null && config.isProxy()) {
            proxy = ipDao.getIp("AK_WEB", MethodType.SEARCH.getTypeName());
            if (proxy == null || StringUtil.isBlank(proxy.getAddress())) {
                return RespEntity.error("获取ip 失败");
            }
        }
        if (StringUtil.isBlank(searchRequestEntity.getCurrency())) {
            searchRequestEntity.setCurrency("CNY");
        }


        try {

            RespEntity contentResp = null;
            contentResp = airaisaWebDao.getWebSearchContent(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity(), searchRequestEntity.getRetDate(), searchRequestEntity.getTripType(), searchRequestEntity.getAdultNum(), searchRequestEntity.getChildNum(), searchRequestEntity.getCurrency(), proxy, "");


//            System.out.println("查询结果为--->"+contentResp.getAttachment());


//            if (proxy != null && StringUtil.isNotBlank(proxy.getAddress())) {
//                ipDao.returnIp("AK_WEB", proxy.getAddress() + ":" + proxy.getPort());
//            }


            if (contentResp == null || contentResp.getStatus() != 200) {
                SearchStatisticsUtil.SearchError();
                return RespEntity.error("获取页面失败");
            }

//        String html = FileUtil.readFile("D:\\test\\airasia\\亚航结果5.txt", "utf-8");
            SearchResponseEntity searchResponseEntity = airaisaWebDao.parserWebContent(contentResp.getAttachment().toString(), searchRequestEntity);
            searchResponseEntity.setUuid(searchRequestEntity.getUuid());
            searchResponseEntity.setSearchId(searchRequestEntity.getSearchId());
            searchResponseEntity.setQueneName(searchRequestEntity.getQueneName());
            searchResponseEntity.setAdultNum(searchRequestEntity.getAdultNum());
            searchResponseEntity.setChildNum(searchRequestEntity.getChildNum());
            searchResponseEntity.setActionId(searchRequestEntity.getActionId());
            //
            if (searchResponseEntity.getFromSegments() != null && searchResponseEntity.getFromSegments().size() > 0) {
                SearchStatisticsUtil.SearchSuccess();
            } else {
                SearchStatisticsUtil.SearchNoData();
            }

//            String content = JSON.toJSONString(searchResponseEntity);
//            if (StringUtil.isNotBlank(content)) {
////                if (content.length() > 100) {
////                    content = content.substring(0, 100);
////                }
////                log.info("返回的结果为--->>{}", content);
//            }
            monitorEntity.setResponseEntity(searchResponseEntity);
//            content = null;
            respEntity = RespEntity.success(searchResponseEntity);

            if (searchResponseEntity.getFromSegments() == null || searchResponseEntity.getFromSegments().size() == 0) {
                respEntity = failException(searchRequestEntity);
            }

        } catch (Exception e) {
            e.printStackTrace();
            respEntity = failException(searchRequestEntity);
//            com.bjlt.spider.exception.MyRetryException retryException = com.bjlt.spider.exception.MyRetryException.builder().searchRequestEntity(searchRequestEntity).message("获取数据为空").build();
//            throw retryException;
        }
        return respEntity;

    }


    /**
     * 新版本
     *
     * @param searchRequestEntity
     * @return
     * @throws Exception
     */
    @Override
    public RespEntity serach2(SearchRequestEntity searchRequestEntity, MonitorEntity monitorEntity) {

        RespEntity respEntity = null;
//        this.searchRequestEntity = searchRequestEntity;
        System.out.println("请求参数为---" + JSON.toJSONString(searchRequestEntity));
        HttpProxy proxy = null;
        if (config != null && config.isProxy()) {
            proxy = ipDao.getIp("AK_WEB", MethodType.SEARCH.getTypeName());
            if (proxy == null || StringUtil.isBlank(proxy.getAddress())) {
                return RespEntity.error("获取ip 失败");
            }
        }
        if (StringUtil.isBlank(searchRequestEntity.getCurrency())) {
            searchRequestEntity.setCurrency("CNY");
        }


        try {

            RespEntity cookie = getSearchCookie(redisTemplate, searchRequestEntity.getFormCity(), searchRequestEntity.getToCity(), searchRequestEntity.getFromDate());
            RespEntity contentResp = null;


            if (cookie == null || cookie.getStatus() != 200) {
                return RespEntity.error("获取cookie失败");
            }


            Map<String, String> cookieMap = CookieUtils.spiltCookies(cookie.getAttachment().toString());
//            if(cookieMap != null && cookieMap.containsKey("ASBD")){
//
//                cookieMap.remove("ASBD");
//            }


            log.info("获取到的cookie为--->{}", JSON.toJSONString(cookieMap));
            contentResp = airaisaWebDao.getWebSearchContent2(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity(), searchRequestEntity.getRetDate(), searchRequestEntity.getTripType(), searchRequestEntity.getAdultNum(), searchRequestEntity.getChildNum(), searchRequestEntity.getCurrency(), proxy, CookieUtils.toString(cookieMap));

            log.info("获取到的第一手数据为-->{}", contentResp.getStatus() + "----" + contentResp.getMessage() + "-----" + Jsoup.parse(contentResp.getAttachment().toString()).title());
//            log.info(contentResp.getAttachment().toString());
            if (proxy != null && StringUtil.isNotBlank(proxy.getAddress())) {
                ipDao.returnIp("AK_WEB", proxy.getAddress() + ":" + proxy.getPort());
            }


//
//            logger.log(SysLogger.builder().name(searchRequestEntity).message(contentResp.getStatus()+"----"+contentResp.getMessage()).build());

            if (contentResp == null || contentResp.getStatus() != 200) {
                SearchStatisticsUtil.SearchError();
                logger.log(SysLogger.builder().name(searchRequestEntity).message(contentResp.getStatus() + "----" + contentResp.getMessage()).build());
                return RespEntity.error("获取页面失败");
            }

//        String html = FileUtil.readFile("D:\\test\\airasia\\亚航结果5.txt", "utf-8");
            SearchResponseEntity searchResponseEntity = airaisaWebDao.parserWebContent(contentResp.getAttachment().toString(), searchRequestEntity);
            searchResponseEntity.setUuid(searchRequestEntity.getUuid());
            searchResponseEntity.setSearchId(searchRequestEntity.getSearchId());
            searchResponseEntity.setQueneName(searchRequestEntity.getQueneName());
            searchResponseEntity.setAdultNum(searchRequestEntity.getAdultNum());
            searchResponseEntity.setChildNum(searchRequestEntity.getChildNum());
            searchResponseEntity.setActionId(searchRequestEntity.getActionId());
            //
            monitorEntity.setResponseEntity(contentResp.getAttachment());
            monitorEntity.setCollectEndDate(new Date());
            if (searchResponseEntity.getFromSegments() != null && searchResponseEntity.getFromSegments().size() > 0) {
                SearchStatisticsUtil.SearchSuccess();
            } else {

                // 如果没有数据，则开始记录日志
                logger.log(SysLogger.builder().name(searchRequestEntity).message(searchResponseEntity).build());


                SearchStatisticsUtil.SearchNoData();
            }

            String content = JSON.toJSONString(searchResponseEntity);
            if (StringUtil.isNotBlank(content)) {
//                if (content.length() > 100) {
//                    content = content.substring(0, 100);
//                }
//                log.info("返回的结果为--->>{}", content);
            }
            content = null;
            respEntity = RespEntity.success(searchResponseEntity);

//            if (searchResponseEntity.getFromSegments() == null || searchResponseEntity.getFromSegments().size() == 0) {
//                respEntity = failException(searchRequestEntity);
//            }

        } catch (Exception e) {
            e.printStackTrace();
//            respEntity = failException(searchRequestEntity);
//            com.bjlt.spider.exception.MyRetryException retryException = com.bjlt.spider.exception.MyRetryException.builder().searchRequestEntity(searchRequestEntity).message("获取数据为空").build();
//            throw retryException;
        }
        return respEntity;

    }

    @Override
    public RespEntity newSerach(SearchRequestEntity searchRequestEntity) {

        RespEntity respEntity = null;
//        this.searchRequestEntity = searchRequestEntity;
        System.out.println("请求参数为---" + JSON.toJSONString(searchRequestEntity));
        HttpProxy proxy = null;
        if (config != null && config.isProxy()) {
            proxy = ipDao.getIp("AK_WEB", MethodType.SEARCH.getTypeName());
            if (proxy == null || StringUtil.isBlank(proxy.getAddress())) {
                return RespEntity.error("获取ip 失败");
            }
        }
        if (StringUtil.isBlank(searchRequestEntity.getCurrency())) {
            searchRequestEntity.setCurrency("CNY");
        }


        try {

            RespEntity contentResp = null;
            contentResp = airaisaWebDao.getWebSearchContent(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity(), searchRequestEntity.getRetDate(), searchRequestEntity.getTripType(), searchRequestEntity.getAdultNum(), searchRequestEntity.getChildNum(), searchRequestEntity.getCurrency(), proxy, "");


//            System.out.println("查询结果为--->"+contentResp.getAttachment());


            if (proxy != null && StringUtil.isNotBlank(proxy.getAddress())) {
                ipDao.returnIp("AK_WEB", proxy.getAddress() + ":" + proxy.getPort());
            }


            if (contentResp == null || contentResp.getStatus() != 200) {
                SearchStatisticsUtil.SearchError();
                return RespEntity.error("获取页面失败");
            }


            NewSearchResponseEntity searchResponseEntity = airaisaWebDao.parserWebContent2(contentResp.getAttachment().toString(), searchRequestEntity);
            searchResponseEntity.setUuid(searchRequestEntity.getUuid());
            searchResponseEntity.setSearchId(searchRequestEntity.getSearchId());
            searchResponseEntity.setQueneName(searchRequestEntity.getQueneName());
            searchResponseEntity.setAdultNum(searchRequestEntity.getAdultNum());
            searchResponseEntity.setChildNum(searchRequestEntity.getChildNum());
            searchResponseEntity.setActionId(searchRequestEntity.getActionId());
            //
            if (searchResponseEntity.getFromSegments() != null && searchResponseEntity.getFromSegments().size() > 0) {
                SearchStatisticsUtil.SearchSuccess();
            } else {

                // 如果没有数据，则开始记录日志
                logger.log(SysLogger.builder().name(searchRequestEntity).message(searchResponseEntity).build());


                SearchStatisticsUtil.SearchNoData();
            }

            String content = JSON.toJSONString(searchResponseEntity);
            if (StringUtil.isNotBlank(content)) {
//                if (content.length() > 100) {
//                    content = content.substring(0, 100);
//                }
                log.info("返回的结果为--->>{}", content);
            }
            content = null;
            respEntity = RespEntity.success(searchResponseEntity);

//            if (searchResponseEntity.getFromSegments() == null || searchResponseEntity.getFromSegments().size() == 0) {
//                respEntity = failException(searchRequestEntity);
//            }

        } catch (Exception e) {
            e.printStackTrace();
//            respEntity = failException(searchRequestEntity);
//            com.bjlt.spider.exception.MyRetryException retryException = com.bjlt.spider.exception.MyRetryException.builder().searchRequestEntity(searchRequestEntity).message("获取数据为空").build();
//            throw retryException;
        }
        return respEntity;

    }


    /**
     * 异常重试处理
     *
     * @param
     */
//    @Recover
    public RespEntity failException(SearchRequestEntity searchRequestEntity) {
        RespEntity respEntity = null;
//        this.searchRequestEntity = searchRequestEntity;
        System.out.println("请求参数为---" + JSON.toJSONString(searchRequestEntity));
        HttpProxy proxy = null;
        if (config != null && config.isProxy()) {
            proxy = ipDao.getIp("AK_WEB", MethodType.SEARCH.getTypeName());
            if (proxy == null || StringUtil.isBlank(proxy.getAddress())) {
                return RespEntity.error("获取ip 失败");
            }
        }
        if (StringUtil.isBlank(searchRequestEntity.getCurrency())) {
            searchRequestEntity.setCurrency("CNY");
        }


        try {

            RespEntity contentResp = null;
            contentResp = airaisaWebDao.getWebSearchContent(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity(), searchRequestEntity.getRetDate(), searchRequestEntity.getTripType(), searchRequestEntity.getAdultNum(), searchRequestEntity.getChildNum(), searchRequestEntity.getCurrency(), proxy, "");

            if (proxy != null && StringUtil.isNotBlank(proxy.getAddress())) {
                ipDao.returnIp("AK_WEB", proxy.getAddress() + ":" + proxy.getPort());
            }
            if (contentResp == null || contentResp.getStatus() != 200) {
                SearchStatisticsUtil.SearchError();
                return RespEntity.error("获取页面失败");
            }

//        String html = FileUtil.readFile("D:\\test\\airasia\\亚航结果5.txt", "utf-8");
            SearchResponseEntity searchResponseEntity = airaisaWebDao.parserWebContent(contentResp.getAttachment().toString(), searchRequestEntity);
            searchResponseEntity.setUuid(searchRequestEntity.getUuid());
            searchResponseEntity.setSearchId(searchRequestEntity.getSearchId());
            searchResponseEntity.setQueneName(searchRequestEntity.getQueneName());
            searchResponseEntity.setAdultNum(searchRequestEntity.getAdultNum());
            searchResponseEntity.setChildNum(searchRequestEntity.getChildNum());
            //
            if (searchResponseEntity.getFromSegments() != null && searchResponseEntity.getFromSegments().size() > 0) {
                SearchStatisticsUtil.SearchSuccess();
            } else {
                SearchStatisticsUtil.SearchNoData();
            }

            String content = JSON.toJSONString(searchResponseEntity);
            if (StringUtil.isNotBlank(content)) {
                if (content.length() > 100) {
                    content = content.substring(0, 100);
                }
//                System.out.println("返回结果为----" + content);
            }
            content = null;

            respEntity = RespEntity.success(searchResponseEntity);


        } catch (Exception e) {
            e.printStackTrace();
        }
        return respEntity;
    }


    @Override
    public RespEntity login(String userName, String passWord) {
        return null;
    }

    @Override
    public RespEntity getBaggage(String depAirport, String arrAirport) {
        HttpProxy proxy = null;
        if (config.isProxy()) {
            ipDao.getIp("AIRAISA", MethodType.SEARCH.getTypeName());
        }
        RespEntity htmlResp = airaisaWebDao.getAdditionalCost(depAirport, arrAirport, proxy);
        if (htmlResp.getStatus() == 200) {
            List<BaggageEntity> baggageEntities = airaisaWebDao.baggageParser(htmlResp.getAttachment().toString());
            if (baggageEntities != null && baggageEntities.size() > 0) {
                baggageEntities.stream().forEach(baggageEntity -> {

                    baggageEntity.setArrAirport(arrAirport);
                    baggageEntity.setDepAirport(depAirport);
                });
            }
            return RespEntity.success(baggageEntities);
        }


        return RespEntity.error("获取失败");
    }


    /**
     * 亚航页面解析
     *
     * @param htrml
     * @param searchRequestEntity
     * @return
     * @date 2017/12/6
     */

    public static SearchResponseEntity parser(String htrml, SearchRequestEntity searchRequestEntity) {

        /**
         * 去程信息
         */
        List<AirlineInfomation> fromSegments = Lists.newArrayList();


        /**
         * 回程航段
         */
        List<AirlineInfomation> retSegments = Lists.newArrayList();
        if (StringUtil.isNotBlank(htrml)) {
            Document document = Jsoup.parse(htrml);
            //  锁定到   航班列表的class
            Element availabilityForm = document.getElementById("availabilityForm");
//            System.out.println(availabilityForm.text());
            if (availabilityForm != null) {
                Elements availabilityContainers = availabilityForm.select("div.js_availability_container");
                if (availabilityContainers != null && availabilityContainers.size() > 0) {
                    //  第一个为出发
                    //   第二个为回程
                    Element fromSegmentsElements = availabilityContainers.get(0);
                    Elements availTables = fromSegmentsElements.select("table.avail-table");
                    if (availTables != null && availTables.size() > 0) {
                        for (Element availTable : availTables) {
                            // 判断是去程还是回程

//                            System.out.println("availTable----" + availTable.text());
//                                Elements fareLightRows = availTable.select("tr.fare-light-row");
                            List<AirlineInfomation> fareLightRowsInfomations = airalinemationParser(availTable, searchRequestEntity, "fare-light-row", 0);
                            List<AirlineInfomation> fareDarkRowInfomations = airalinemationParser(availTable, searchRequestEntity, "fare-dark-row", 0);
                            fromSegments.addAll(fareLightRowsInfomations);
                            fromSegments.addAll(fareDarkRowInfomations);


                        }
                    }
//
                    if (availabilityContainers.size() > 1) {
// 说明是返程
                        Element retSegmentsElements = availabilityContainers.get(1);
                        Elements retavailTables = retSegmentsElements.select("table.avail-table");
                        if (availTables != null && availTables.size() > 0) {
                            for (Element availTable : retavailTables) {

                                List<AirlineInfomation> fareLightRowsInfomations = airalinemationParser(availTable, searchRequestEntity, "fare-light-row", 1);
                                List<AirlineInfomation> fareDarkRowInfomations = airalinemationParser(availTable, searchRequestEntity, "fare-dark-row", 1);
                                retSegments.addAll(fareLightRowsInfomations);
                                retSegments.addAll(fareDarkRowInfomations);


                            }
                        }

                    }
                }


            }
        }

//        System.out.println("去程----" + JSON.toJSONString(fromSegments));
//        System.out.println("返程----" + JSON.toJSONString(retSegments));
        // now  往出发行程里 添加出发到达城市
        // 去程
        List<AirlineInfomation> newFromSegment = new ArrayList<>();
        List<AirlineInfomation> newRetSegment = new ArrayList<>();
        if (fromSegments != null && fromSegments.size() > 0) {
            for (AirlineInfomation fromSegment : fromSegments) {
                fromSegment.setFromDate(searchRequestEntity.getFromDate());
                fromSegment.setFormCity(searchRequestEntity.getFormCity());
                fromSegment.setToCity(searchRequestEntity.getToCity());
                fromSegment.setAirSourceName(SourceEnum.AK_WEB.getSourceName());
                fromSegment.setRetDate(searchRequestEntity.getRetDate());
                removeStopOver(fromSegment);

                newFromSegment.add(fromSegment);
                System.out.println("去程---" + JSON.toJSONString(fromSegment));
            }
        }


        if (retSegments != null && retSegments.size() > 0) {
            for (AirlineInfomation retSegment : retSegments) {
                retSegment.setAirSourceName(SourceEnum.AK_WEB.getSourceName());
                retSegment.setFormCity(searchRequestEntity.getToCity());
                retSegment.setFromDate(searchRequestEntity.getRetDate());
                retSegment.setToCity(searchRequestEntity.getFormCity());
                retSegment.setRetDate(searchRequestEntity.getFromDate());
                removeStopOver(retSegment);
                System.out.println("回程---" + JSON.toJSONString(retSegment));
                newRetSegment.add(retSegment);
            }
        }


        SearchResponseEntity searchResponseEntity = SearchResponseEntity.builder().formCity(searchRequestEntity.getFormCity()).fromDate(searchRequestEntity.getFromDate()).retDate(searchRequestEntity.getRetDate()).toCity(searchRequestEntity.getToCity()).fromSegments(newFromSegment).retSegments(newRetSegment).tripType(searchRequestEntity.getTripType()).build();
        return searchResponseEntity;
    }


    /**
     * 对航班的处理
     *
     * @param fromSegment
     */
    public static void removeStopOver(AirlineInfomation fromSegment) {
        List<RouteInfoEntity> routeInfoEntityLists = new ArrayList<>();
        // 在此处多增加一步处理，将经停的的中转合成一起
        List<RouteInfoEntity> routeInfoEntities = fromSegment.getRouteInfoEntities();
        //这里对时间 再进行一波处理
        Date temp = null;
        List<RouteInfoEntity> routeInfoEntitiesList = new ArrayList<>();
        for (RouteInfoEntity routeInfoEntity : routeInfoEntities) {
            Date startDate = DateUtil.getFormatDate(routeInfoEntity.getDepTime(), "yyyyMMddHHmm");
            Date endDate = DateUtil.getFormatDate(routeInfoEntity.getArrTime(), "yyyyMMddHHmm");
            if (temp != null) {
                if (comopareTime(temp, startDate) == false) {
                    DateUtil.getBeforeDay(startDate, -1);
                }
            }


            if (comopareTime(startDate, endDate) == false) {
                // 如果出发时间大于到达时间，则出发时间+1
                DateUtil.getBeforeDay(endDate, -1);
            }
            routeInfoEntity.setDepTime(DateUtil.getFormatDate(startDate, "yyyyMMddHHmm"));
            routeInfoEntity.setArrTime(DateUtil.getFormatDate(endDate, "yyyyMMddHHmm"));
            temp = endDate;
            routeInfoEntitiesList.add(routeInfoEntity);
        }
        if (routeInfoEntitiesList != null && routeInfoEntitiesList.size() > 0) {
            Map<String, RouteInfoEntity> map = new HashMap<>();
            for (RouteInfoEntity routeInfoEntity : routeInfoEntitiesList) {

                String flightNumber = routeInfoEntity.getFlightNumber();
                if (map.containsKey(flightNumber)) {
                    //  当map 的key 中包含 航班号的时候，说明此航班为 经停站 ,将上一个航班的出发城市&& 时间加上这个航班的到达城市&& 时间
                    RouteInfoEntity oldRouteInfoEntity = map.get(flightNumber);
                    map.remove(flightNumber);

                    RouteInfoEntity newRouteInfoEntity = new RouteInfoEntity();
                    newRouteInfoEntity.setFlightNumber(flightNumber);
                    newRouteInfoEntity.setCarrier(routeInfoEntity.getCarrier());
                    newRouteInfoEntity.setDepAirport(oldRouteInfoEntity.getDepAirport());
                    newRouteInfoEntity.setDepTime(oldRouteInfoEntity.getDepTime());
                    newRouteInfoEntity.setArrAirport(routeInfoEntity.getArrAirport());
                    newRouteInfoEntity.setArrTime(routeInfoEntity.getArrTime());
                    // 精通分钟数
                    long minute = 0;
                    if (StringUtil.isNotBlank(oldRouteInfoEntity.getArrTime()) && StringUtil.isNotBlank(routeInfoEntity.getDepTime())) {
                        minute = DateUtil.dateDiff(DateUtil.getFormatDate(oldRouteInfoEntity.getArrTime(), "yyyyMMddHHmm"), DateUtil.getFormatDate(routeInfoEntity.getDepTime(), "yyyyMMddHHmm"), Calendar.MINUTE);
                    }
//                    System.out.println(DateUtil.getFormatDate(routeInfoEntity.getDepTime(), "yyyyMMddHHmm") + "___" + DateUtil.getFormatDate(oldRouteInfoEntity.getArrTime(), "yyyyMMddHHmm") + "___" + minute);
                    StopCityEntity stopCityEntity = StopCityEntity.builder().arrTime(oldRouteInfoEntity.getArrTime()).depTime(routeInfoEntity.getDepTime()).name(oldRouteInfoEntity.getArrAirport()).minutes(new Long(minute).intValue()).build();
                    newRouteInfoEntity.setStopCitiesEntity(stopCityEntity);
                    newRouteInfoEntity.setStopCities(stopCityEntity.getName());
                    newRouteInfoEntity.setCabin(routeInfoEntity.getCabin());
                    newRouteInfoEntity.setAircraftCode(routeInfoEntity.getAircraftCode());
                    map.put(flightNumber, newRouteInfoEntity);


                } else {
                    map.put(routeInfoEntity.getFlightNumber(), routeInfoEntity);
                }


            }
            for (Map.Entry<String, RouteInfoEntity> entityEntry : map.entrySet()) {
                routeInfoEntityLists.add(entityEntry.getValue());
            }
        }

        LinkedList<RouteInfoEntity> sortRouteInfoEntities = new LinkedList<>();
        if (routeInfoEntityLists != null && routeInfoEntityLists.size() > 0) {

            for (RouteInfoEntity routeInfoEntity : routeInfoEntityLists) {
                if (routeInfoEntity.getDepAirport().equals(fromSegment.getFormCity())) {
                    sortRouteInfoEntities.addFirst(routeInfoEntity);
                } else {
                    sortRouteInfoEntities.addLast(routeInfoEntity);
                }
            }
        }


        logger.info(SysLogger.builder().name("排序后").message(sortRouteInfoEntities).build());

        fromSegment.setRouteInfoEntities(sortRouteInfoEntities);
    }

    /**
     * @param availTable
     * @param searchRequestEntity
     * @param className
     * @param triptype
     * @return
     */
    public static List<AirlineInfomation> airalinemationParser(Element availTable, SearchRequestEntity searchRequestEntity, String className, int triptype) {
        List<AirlineInfomation> airlineInfomations = new ArrayList<>();
        Elements fareDarkRows = availTable.select("tr." + className);
        if (fareDarkRows != null && fareDarkRows.size() > 0) {
            for (Element fareDarkRow : fareDarkRows) {
                //     计算飞行时长
                String flightTime = null;
                Elements availStopsInfos = fareDarkRow.select("td.avail-stops-info");
                if (availStopsInfos != null && availStopsInfos.size() > 0) {
                    for (Element availStopsInfo : availStopsInfos) {
                        Elements textCenters = availStopsInfo.select("div.text-center");
                        if (textCenters != null && textCenters.size() > 0) {
                            for (Element textCenter : textCenters) {
//                                System.out.println("textCenter...." + textCenter.text());
                                String textConterText = textCenter.text();
                                if (StringUtil.isNotBlank(textConterText) && (textConterText.contains("m") || textConterText.contains("h") || textConterText.contains("d"))) {
                                    flightTime = textConterText;

                                }
                            }
                        }
                    }
                }


                AirlineInfomation airlineInfomation = new AirlineInfomation();
                airlineInfomation.setDurationTotal(CommonUtils.converTime(flightTime));

                List<String> flightNumber = Lists.newArrayList();
                List<RouteInfoEntity> routeInfoEntities = new ArrayList<>();
                // 从里面 摘除起飞到达机场，时间和价格
                Elements availTableVerts = fareDarkRow.select("td.avail-table-vert");
//                System.out.println("availTableVerts----" + availTableVerts.text());
                if (availTableVerts != null && availTableVerts.size() > 0) {
                    for (Element availTableVert : availTableVerts) {
                        Elements availTableInfos = availTableVert.select("table.avail-table-info");
                        if (availTableInfos != null && availTableInfos.size() > 0) {
                            for (Element availTableInfo : availTableInfos) {
                                String depTimeStr = null;
                                String arrTimeStr = null;
                                Date time = null;
                                if (triptype == 0) {
                                    // 去程
                                    time = DateUtil.getFormatDate(searchRequestEntity.getFromDate(), DatePattren.TIME_FORMAT);
                                    depTimeStr = searchRequestEntity.getFromDate();
                                    arrTimeStr = searchRequestEntity.getFromDate();
                                } else {
                                    depTimeStr = searchRequestEntity.getRetDate();
                                    arrTimeStr = searchRequestEntity.getRetDate();
                                    time = DateUtil.getFormatDate(searchRequestEntity.getRetDate(), DatePattren.TIME_FORMAT);
                                }


//                                if (StringUtil.isNotBlank(searchRequestEntity.getRetDate())) {
//                                    depTimeStr = searchRequestEntity.getFromDate();
//                                    arrTimeStr = searchRequestEntity.getRetDate();
//                                    time = DateUtil.getFormatDate(searchRequestEntity.getRetDate(), DatePattren.TIME_FORMAT);
//                                } else {
//                                    time = DateUtil.getFormatDate(searchRequestEntity.getFromDate(), DatePattren.TIME_FORMAT);
//                                    depTimeStr = searchRequestEntity.getFromDate();
//                                    arrTimeStr = searchRequestEntity.getFromDate();
//                                }
                                Elements fareDarkRowss = availTableInfo.select("tr." + className);

//                                String depTimeStr = searchRequestEntity.getFromDate();
                                // 判断是否是最后一天
                                boolean depTimelastDays = false;
                                Date depTimeDate = null;
                                if (StringUtil.isNotBlank(depTimeStr)) {
                                    depTimelastDays = isLastDay(depTimeStr);
                                    depTimeDate = DateUtil.getFormatDate(depTimeStr, DatePattren.DATE_FORMAT);
                                }


//                                String arrTimeStr = searchRequestEntity.getRetDate();
                                // 判断是否是最后一天
                                boolean arrTimeStrlastDays = false;
                                Date arrTimeDate = null;
                                if (StringUtil.isNotBlank(arrTimeStr)) {
                                    arrTimeStrlastDays = isLastDay(arrTimeStr);
                                    arrTimeDate = DateUtil.getFormatDate(arrTimeStr, DatePattren.DATE_FORMAT);
                                }


//                                Date depTimeDate = DateUtil.getFormatDate(depTimeStr, DatePattren.DATE_FORMAT);
//
//                                Date arrTimeDate = null;
                                if (StringUtil.isNotBlank(arrTimeStr)) {
                                    arrTimeDate = DateUtil.getFormatDate(arrTimeStr, DatePattren.DATE_FORMAT);
                                }


                                if (fareDarkRowss != null && fareDarkRowss.size() > 0) {
                                    for (Element fare : fareDarkRowss) {
//                                        System.out.println(fare.text());
                                        //中转信息
                                        RouteInfoEntity routeInfoEntity = new RouteInfoEntity();
                                        Elements textCenters = fare.select("div.text-center");
                                        // 这里需要收拾一下时间

                                        if (textCenters != null && textCenters.size() > 0) {
                                            // 出发机场
                                            String depAirport = textCenters.get(0).select("div").get(0).text();
                                            String depTime = textCenters.get(0).select("div").get(1).text();
                                            String arrAirport = textCenters.get(1).select("div").get(0).text();
                                            String arrTime = textCenters.get(1).select("div").get(1).text();

                                            if (depAirport.contains("+1") || depTimelastDays == true) {
                                                if (depTimeDate != null) {
                                                    depTimeDate = DateUtil.getBeforeDay(depTimeDate, -1);
//                                                    arrTimeDate = DateUtil.getBeforeDay(arrTimeDate, -1);

                                                }


                                            }
                                            if (arrAirport.contains("+1") || arrTimeStrlastDays == true) {
                                                arrTimeDate = DateUtil.getBeforeDay(arrTimeDate, -1);
//                                                depTimeDate = DateUtil.getBeforeDay(depTimeDate, -1);
                                                time = DateUtil.getBeforeDay(time, -1);
                                            }


                                            try {
                                                if (time != null && DateUtil.getDaysBetween(arrTimeDate, time) > 0) {
//                                                    time = DateUtil.getBeforeDay(time, -1);
                                                }
                                            } catch (ParseException e) {
                                                e.printStackTrace();
                                            }


                                            System.out.println(time);

                                            // 取出出发机场和到达机场
                                            depAirport = depAirport.replace(depTime, "").trim().replace("+1", "").replace("(", "").replace(")", "");
                                            arrAirport = arrAirport.replace(arrTime, "").trim().replace("+1", "").replace("(", "").replace(")", "");

                                            depAirport = depAirport.replaceAll(" ", "");
                                            routeInfoEntity.setDepAirport(depAirport);
                                            routeInfoEntity.setCabin("E");

                                            String depTimeRemove = DateUtil.getFormatDate(depTimeDate, DatePattren.DATE_FORMAT) + "" + depTime;


                                            depTimeRemove = depTimeRemove.replaceAll("-", "").replaceAll(":", "");
                                            routeInfoEntity.setDepTime(depTimeRemove);

                                            String arrTimeRemove = DateUtil.getFormatDate(arrTimeDate, DatePattren.DATE_FORMAT) + "" + arrTime;
                                            arrTimeRemove = arrTimeRemove.replaceAll("-", "").replaceAll(":", "");


                                            logger.info(SysLogger.builder().name("depTimeRemove").message(depTimeRemove).build());
                                            logger.info(SysLogger.builder().name("arrTimeRemove").message(arrTimeRemove).build());


                                            arrAirport = arrAirport.replaceAll(" ", "");
                                            routeInfoEntity.setArrAirport(arrAirport);

                                            routeInfoEntity.setAircraftCode("320");
                                            routeInfoEntity.setArrTime(arrTimeRemove);

                                            depTimeDate = arrTimeDate;
                                            time = arrTimeDate;
//                                            routeInfoEntity.setStopCities("");
                                        }
//                                        System.out.println("fare ----" + JSON.toJSONString(routeInfoEntity));
                                        routeInfoEntities.add(routeInfoEntity);
                                    }
                                }

                                // 处理航班号
                                Elements carrierHovers = availTableInfo.select("div.carrier-hover-bold");
//                                System.out.println("航班号---" + carrierHovers.select("div.carrier-hover-bold").size());
                                if (carrierHovers != null && carrierHovers.size() > 0) {
                                    for (Element carrierHover : carrierHovers) {
                                        flightNumber.add(carrierHover.text());
                                    }
                                }


                            }
                        }

                    }
                }
//                System.out.println(flightNumber.size());
                if (routeInfoEntities != null && flightNumber != null && routeInfoEntities.size() == flightNumber.size()) {
                    for (int i = 0; i < routeInfoEntities.size(); i++) {
                        String flightNumberStr = flightNumber.get(i);
                        flightNumberStr = flightNumberStr.replaceAll(" ", "");
                        routeInfoEntities.get(i).setFlightNumber(flightNumberStr);
                        routeInfoEntities.get(i).setCarrier(flightNumber.get(i).substring(0, 2));
                    }

                }


                Elements availTableTopBorderBlacks = fareDarkRow.select("td.avail-fare");
//                System.out.println(availTableTopBorderBlacks.text());
                // 价格信息
                List<AirlinePriceInfo> airlinePriceInfos = new ArrayList<>();
                if (availTableTopBorderBlacks != null && availTableTopBorderBlacks.size() > 0) {
                    //  获取价格
                    for (Element availTableTopBorderBlack : availTableTopBorderBlacks) {
                        String adultPriceStr = null; // 大人价格
                        String childPriceStr = null;// 小孩子价格
                        String currency = null; // 币种
                        //  价格信息
                        AirlinePriceInfo airlinePriceInfo = new AirlinePriceInfo();


                        //  取出价格
                        Elements availFarePrices = availTableTopBorderBlack.select("div.avail-fare-price");
                        if (availFarePrices != null && availFarePrices.size() > 0) {
                            adultPriceStr = availFarePrices.get(0).text();
                            if (availFarePrices.size() > 1) {
                                childPriceStr = availFarePrices.get(1).text();
                            }
                        }
                        if (StringUtil.isNotBlank(adultPriceStr)) {
                            currency = CurrencyUtils.currencyIdentification(adultPriceStr);
                            adultPriceStr = adultPriceStr.replaceAll(currency, "").replaceAll("≈", "").replaceAll(",", "").replaceAll(" ", "");
                        }
                        if (StringUtil.isNotBlank(childPriceStr)) {
                            childPriceStr = childPriceStr.replaceAll(currency, "").replaceAll("≈", "").replaceAll(",", "").replaceAll(" ", "");
                        }

                        //  航班剩余数 默认为5
                        int maxSeats = 5;
                        Elements availTableSeatsRemaining = availTableTopBorderBlack.select("div.avail-table-seats-remaining");
                        if (availTableSeatsRemaining != null && availTableSeatsRemaining.size() > 0) {
                            String availTableSeatsRemainingStr = availTableSeatsRemaining.get(0).text();
                            if (StringUtil.isNotBlank(availTableSeatsRemainingStr)) {
                                String pagex = "[0-9]+";
                                String regex = RegexUtil.get(pagex, availTableSeatsRemainingStr, 0);
                                if (StringUtil.isNotBlank(regex)) {
                                    maxSeats = Integer.parseInt(regex);
                                }
                            }
                        }
                        airlinePriceInfo.setMaxSeats(maxSeats);
                        //  处理价格，将 String 转为Bigde

                        BigDecimal adultPrice = null;
                        BigDecimal childPrice = null;
                        BigDecimal adultTax = null;
                        BigDecimal childTax = null;
                        if (StringUtil.isNotBlank(adultPriceStr)) {

                            BigDecimal adultPriceAll = new BigDecimal(adultPriceStr);
                            adultPrice = adultPriceAll.multiply(new BigDecimal(0.9)).setScale(2, BigDecimal.ROUND_HALF_UP);
                            adultTax = adultPriceAll.multiply(new BigDecimal(0.1)).setScale(2, BigDecimal.ROUND_HALF_UP);

                        } else {
                            adultPrice = new BigDecimal(0);
                            childPrice = new BigDecimal(0);
                        }
                        if (StringUtil.isNotBlank(childPriceStr)) {
                            BigDecimal childPriceAll = new BigDecimal(childPriceStr);
                            childPrice = childPriceAll.multiply(new BigDecimal(0.9)).setScale(2, BigDecimal.ROUND_HALF_UP);
                            childTax = childPriceAll.multiply(new BigDecimal(0.1)).setScale(2, BigDecimal.ROUND_HALF_UP);

                        } else {
                            childPrice = new BigDecimal(0);
                            childTax = new BigDecimal(0);
                        }
                        airlinePriceInfo.setAdultPrice(adultPrice);
                        airlinePriceInfo.setAdultTax(adultTax);
                        airlineInfomation.setCurrency(currency);
                        airlinePriceInfo.setChildPrice(childPrice);
                        airlinePriceInfo.setChildTax(childTax);
                        // 取出下面的第一个input ，根据input 判断此价格信息为普通舱位还是豪华舱位
                        String dataProductclass = null;
                        Elements inputs = availTableTopBorderBlack.select("input");
                        if (inputs != null && inputs.size() > 0) {
                            dataProductclass = inputs.get(0).attr("data-productclass");
                        }

                        logger.info(SysLogger.builder().name("dataProductclass").message(dataProductclass).build());

                        if (StringUtil.isNotBlank(dataProductclass)) {
                            if (dataProductclass.startsWith("EC")) {
                                //  低航费
                                airlinePriceInfo.setCabin("EC");
                                airlinePriceInfo.setCabinclass("0");
                                airlinePriceInfo.setCabinName("促销");

                            } else if (dataProductclass.startsWith("EP")) {
                                airlinePriceInfo.setCabin("EP");
                                airlinePriceInfo.setCabinclass("1");
                                airlinePriceInfo.setCabinName("低航费");
                            } else if (dataProductclass.startsWith("HF")) {
                                airlinePriceInfo.setCabin("HF");
                                airlinePriceInfo.setCabinclass("2");
                                airlinePriceInfo.setCabinName("常飞客");
                            } else if (dataProductclass.startsWith("PM")) {
                                airlinePriceInfo.setCabin("PM");
                                airlinePriceInfo.setCabinclass("3");
                                airlinePriceInfo.setCabinName("豪华平躺座椅");
                            }
                        }

                        logger.info(SysLogger.builder().message(adultPriceStr + "___" + childPriceStr).build());

                        if (airlinePriceInfo != null && airlinePriceInfo.getAdultTax() != null && airlinePriceInfo.getAdultTax().compareTo(new BigDecimal(0)) != 0) {
                            airlinePriceInfos.add(airlinePriceInfo);
                        }


                    }


                }
                airlineInfomation.setAirlinePriceInfos(airlinePriceInfos);
                airlineInfomation.setRouteInfoEntities(routeInfoEntities);
                // 接下来处理航班
                logger.info(SysLogger.builder().message(airlineInfomation).build());

                if (airlineInfomation.getRouteInfoEntities().size() != 0) {
                    airlineInfomations.add(airlineInfomation);
                }

            }
        }
        return airlineInfomations;
    }


    /**
     * 获取页面内容
     *
     * @param url       地址
     * @param headerMap 头部信息
     * @param proxy     是否启动代理ip
     * @param airSource 数据源标识
     * @return
     * @throws Exception
     */
    public String getContentFromAirAsiaWeb(String url, Map<String, String> headerMap, boolean proxy, String airSource, HttpProxy proxyPojo) {
        String content = null;

        try {
            if (proxy) {
                //取出ip

                if (proxyPojo != null && StringUtil.isNotBlank(proxyPojo.getAddress())) {
                    log.info(url + "--------启用代理ip" + JSON.toJSONString(proxyPojo));
                    // 使用代理ip

//					System.out.println("ip----"+JSON.toJSONString(proxyPojo));
////					ProxyPojo proxyPojo = new ProxyPojo();
////                   proxyPojo.setIp(proxyEntity.getIp());
////                   proxyPojo.setPort(proxyEntity.getPort());
////                    content = OkHttpDownLoader.get(url).connectTimeOut(50).readTimeOut(50).writeTimeOut(50).addProxy(proxyEntity.getIp(), proxyEntity.getPort()).addHeaders(headerMap).asString();
//					HttpResponse indexResponse = OkHttpDownLoader.get("https://www.airasia.com").ispost302Rediret(false).addProxy(proxyPojo).execute();
//
//					String location =  indexResponse.getResponseHeaders().get("Location").toString();
//					String cookie = indexResponse.getCookies();
//					System.out.println(location+"____"+cookie);
                    headerMap.put("referer", "https://www.airasia.com/cn/zh/home.page?cid=1");
                    headerMap.put("Cookie", "currencySelect=HKD");
                    content = OkHttpDownLoader.get(url).addHeaders(headerMap).addProxy(proxyPojo).okhttpexecute().asString();

                    // 先  获取首页的cookie
//                    HttpResponse indexResponse = OkHttpDownLoader.get("https://www.airasia.com/").add

                    // 线程超时设置
                    ExecutorService executorService = Executors.newFixedThreadPool(1);
                    try {

                        boolean finalProxy = proxy;
                        CompletableFuture<String> future = CompletableFuture.supplyAsync(() -> {
                            try {
                                Thread.sleep(1000 * 5);
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }

                            return null;
                        }, executorService);
//                        future.get(1000*5, TimeUnit.MILLISECONDS);
                    } catch (Exception e) {
                        RespEntity.error(RespCode.PROGRAM_SPIDERT_ERROR, e);
                        log.error("页面采集失败,ip--" + JSON.toJSONString(proxyPojo), e);
                    } finally {
                        executorService.shutdown();
                    }
                } else {
                    log.info("ip获取失败---{}", url);
                    // 不使用代理ip
                    log.info(url + "--------不启用代理ip");

//					content = OkHttpDownLoader.get(url).addHeaders(headerMap).asString();
                    HttpResponse indexResponse = OkHttpDownLoader.get("https://www.airasia.com").http302Rediret(false).okhttpexecute();

                    String location = indexResponse.getResponseHeaders().get("Location").toString();
                    String cookie = indexResponse.getResponseCookie();
                    System.out.println(location + "____" + cookie);
                    headerMap.put("referer", location);
                    headerMap.put("Cookie", cookie + "currencySelect=HKD");
                    content = OkHttpDownLoader.get(url).addHeaders(headerMap).okhttpexecute().asString();

                }
            } else {
                // 不使用代理ip
                log.info(url + "--------不启用代理ip");

//				content = OkHttpDownLoader.get(url).connectTimeOut(50).readTimeOut(50).writeTimeOut(50).addProxy(proxyEntity.getIp(), proxyEntity.getPort()).addHeaders(headerMap).asString();
                HttpResponse indexResponse = OkHttpDownLoader.get("https://www.airasia.com").http302Rediret(false).okhttpexecute();

                String location = indexResponse.getResponseHeaders().get("Location").toString();
                String cookie = indexResponse.getResponseCookie();
//				System.out.println(location+"____"+cookie);
                headerMap.put("referer", location);
                headerMap.put("Cookie", cookie + "currencySelect=HKD");
                content = OkHttpDownLoader.get(url).addHeaders(headerMap).okhttpexecute().asString();

//				Map<String, String> indexResult = ParityHttpUtil.getUrl("https://www.airasia.com/cn/zh/home.page?cid=1", headerMap);
////                       content = indexResult.get("html");
//				String setCookie = indexResult.get("setCookie");
//				System.out.println("首页的cookie值为----"+setCookie);
//				// 接下来访问   获取内容的url
//				headerMap.put("referer", "https://www.airasia.com/cn/zh/home.page?cid=1");
//				headerMap.put("Cookie", setCookie);
//				Map<String, String> result = ParityHttpUtil.getUrl(url, headerMap);
//				content = result.get("html");
            }

        } catch (Exception e) {
            e.printStackTrace();
            log.error(url + "获取页面失败", e);
            // 当失败的时候，重新获取一次

//			content = OkHttpDownLoader.get(url).addHeaders(headerMap).asString();
            HttpResponse indexResponse = OkHttpDownLoader.get("https://www.airasia.com").http302Rediret(false).okhttpexecute();

            String location = indexResponse.getResponseHeaders().get("Location").toString();
            String cookie = indexResponse.getResponseCookie();
//			System.out.println(location+"____"+cookie);
            headerMap.put("referer", location);
            headerMap.put("Cookie", cookie + "currencySelect=HKD");
            content = OkHttpDownLoader.get(url).addHeaders(headerMap).okhttpexecute().asString();

        }
        return content;
    }

    /**
     * 2017/11/30  update  page
     *
     * @param url       地址
     * @param headerMap 头部信息
     * @param proxy     是否启动代理ip
     * @param airSource 数据源标识
     * @return
     * @throws Exception
     */
    public String getContentFromAirAsiaWeb2(String url, Map<String, String> headerMap, boolean proxy, String airSource, HttpProxy proxyPojo) {
        System.out.println("url-----" + url);
        String content = null;
        Map<String, String> headers = new HashMap<>();
        headers.put("Host", "booking.airasia.com");
        headers.put("Connection", "keep-alive");
        headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36");
        headers.put("Upgrade-Insecure-Requests", "1");
        headers.put("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Accept-Language", "zh-CN,zh;q=0.9");
        try {
            //取出ip

            if (proxyPojo != null && StringUtil.isNotBlank(proxyPojo.getAddress())) {
                log.info(url + "--------启用代理ip" + JSON.toJSONString(proxyPojo));
                // 使用代理ip

                HttpResponse indexResponse = OkHttpDownLoader.get(url).addHeaders(headers).http302Rediret(false).addProxy(proxyPojo).okhttpexecute();
                System.out.println(indexResponse.getResponseCookie());
                headers.put("Cookie", indexResponse.getResponseCookie() + ";i10c_waited=true");
                content = OkHttpDownLoader.get(url).addHeaders(headers).addProxy(proxyPojo).okhttpexecute().asString();//                    content = OkHttpDownLoader.get(url).addHeaders(headerMap).addProxy(proxyPojo).execute().asString();

                // 先  获取首页的cookie
//                    HttpResponse indexResponse = OkHttpDownLoader.get("https://www.airasia.com/").add

                // 线程超时设置
                ExecutorService executorService = Executors.newFixedThreadPool(1);
                try {

                    boolean finalProxy = proxy;
                    CompletableFuture<String> future = CompletableFuture.supplyAsync(() -> {
                        try {
                            Thread.sleep(1000 * 5);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }

                        return null;
                    }, executorService);
//                        future.get(1000*5, TimeUnit.MILLISECONDS);
                } catch (Exception e) {
                    RespEntity.error(RespCode.PROGRAM_SPIDERT_ERROR, e);
                    log.error("页面采集失败,ip--" + JSON.toJSONString(proxyPojo), e);
                } finally {
                    executorService.shutdown();
                }
            } else {
                log.info("ip获取失败---{}", url);
                // 不使用代理ip
                log.info(url + "--------不启用代理ip");

                HttpResponse indexResponse = OkHttpDownLoader.get(url).addHeaders(headers).http302Rediret(false).okhttpexecute();
                System.out.println(indexResponse.getResponseCookie());
                headers.put("Cookie", indexResponse.getResponseCookie() + ";i10c_waited=true");
                content = OkHttpDownLoader.get(url).addHeaders(headers).okhttpexecute().asString();//

            }
        } catch (Exception e) {
            e.printStackTrace();
            log.error(url + "获取页面失败", e);
            // 当失败的时候，重新获取一次

//			content = OkHttpDownLoader.get(url).addHeaders(headerMap).asString();
            HttpResponse indexResponse = OkHttpDownLoader.get("https://www.airasia.com").http302Rediret(false).okhttpexecute();

            String location = indexResponse.getResponseHeaders().get("Location").toString();
            String cookie = indexResponse.getResponseCookie();
//			System.out.println(location+"____"+cookie);
            headerMap.put("referer", location);
            headerMap.put("Cookie", cookie + "currencySelect=HKD");
            content = OkHttpDownLoader.get(url).addHeaders(headerMap).okhttpexecute().asString();

        }
        return content;
    }

    public static void main(String[] args) {
//        System.out.println(DateUtil.date(DatePattren.TIME_FORMAT_MILLI));
        SearchRequestEntity searchRequestEntity = new SearchRequestEntity();
        searchRequestEntity.setAdultNum(2);
        searchRequestEntity.setFormCity("PEK");
        searchRequestEntity.setFromDate("2018-02-15");
        searchRequestEntity.setToCity("TRZ");
        searchRequestEntity.setChildNum(0);
        searchRequestEntity.setRetDate("2018-03-15");


        AirAsiaWebServiceImpl airAsiaWebService = new AirAsiaWebServiceImpl();

//        System.out.println(respEntity);
        try {
//            RespEntity respEntity  =   airAsiaWebService.serach(searchRequestEntity);
//            System.out.println(JSON.toJSONString(respEntity));
//            System.out.println(DateUtil.date(DatePattren.TIME_FORMAT_MILLI));
            String html = FileUtil.readFile("D:/亚航结果5.txt", "utf-8");

            SearchResponseEntity responseEntities = parser(html, searchRequestEntity);
            System.out.println("结果为-----" + JSON.toJSONString(responseEntities));
////            SearchResponseEntity searchResponseEntity = new SearchResponseEntity();
////            searchResponseEntity.setFormCity("IXC");
////            searchResponseEntity.setToCity("BLR");
//            SearchResponseEntity responseEntity = new SearchResponseEntity();
//            SearchResponseEntity responseEntities2 = airAsiaWebService.contentParser3(responseEntity, html);
//            System.out.println(JSON.toJSONString(responseEntities2));
        } catch (Exception e) {
            e.printStackTrace();
        }


    }


    /**
     * 根据时间判断是不是月末
     *
     * @param time
     * @return
     */
    public static boolean isLastDay(String time) {
        boolean flg = false;
        try {
            Date date = DateUtil.getFormatDate(time, DatePattren.DATE_FORMAT);
            String lastDay = DateUtil.monthLastDate(date);
            if (time.equals(lastDay)) {
                flg = true;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return flg;
    }


    /**
     * 比较时间，如果 start 比end 大，返回false，否则返回true
     *
     * @param start
     * @param end
     * @return
     */
    public static boolean comopareTime(Date start, Date end) {
        boolean flg = true;

        if (start.getTime() > end.getTime()) {
            flg = false;
        } else {
            flg = true;
        }
        return flg;
    }

}
