package com.bjlt.spider.business.cebupacificair.service.impl;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.airasia.dao.IpDao;
import com.bjlt.spider.business.cebupacificair.service.CebupacificairService;
import com.bjlt.spider.cebupacificair.dao.CebupacificairSearchDao;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.util.MethodType;
import com.bjlt.spider.util.RespEntity;
import com.luyn.core.StringUtil;
import com.luyn.http.proxy.HttpProxy;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class CebupacificairServiceImpl implements CebupacificairService {

    @Autowired
    CebupacificairSearchDao cebupacificairSearchDao;

    @Autowired
    private IpDao ipDao;

    @Autowired
    Config config;

    @Override
    public RespEntity search(SearchRequestEntity searchRequestEntity) {

        try{
            long statTime = System.currentTimeMillis();
            // 进行 非空验证
            if (StringUtil.hasBlank(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity())) {
                return RespEntity.error("请求参数不正确");

            }
            if (StringUtil.isBlank(searchRequestEntity.getCurrency())) {
                searchRequestEntity.setCurrency("CNY");
            }
            HttpProxy proxy = null;
            if(config != null && config.isProxy()){
                proxy = ipDao.getIp("Cebupacificair_Mobile", MethodType.SEARCH.getTypeName());
                if(proxy == null || StringUtil.isBlank(proxy.getAddress())){
                    return  RespEntity.error("获取ip 失败");
                }
            }
            System.out.println("获取代理："+ JSON.toJSONString(proxy));
            System.out.println(System.currentTimeMillis());
            SearchResponseEntity searchResponseEntity = cebupacificairSearchDao.SearchPc(searchRequestEntity,proxy);
            if(proxy != null && StringUtil.isNotBlank(proxy.getAddress())){
                ipDao.returnIp("Cebupacificair_Mobile",proxy.getAddress()+":"+proxy.getPort());
            }
            long endTime = System.currentTimeMillis();
            System.out.println("耗时："+((endTime-statTime)/1000)+"s");
            return RespEntity.success(searchResponseEntity);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return RespEntity.error("search 失败");
    }

}
