package com.bjlt.spider.business.common.dao;

import com.bjlt.spider.utils.CommonUtils;
import com.luyn.core.RandomUtil;
import com.luyn.core.StringUtil;
import com.luyn.http.proxy.HttpProxy;
import com.luyn.json.JsonUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Repository;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

/**
 * @author: luyanan0718@163.com
 * @create :2018/3/9 15:10
 * @introduce :
 **/

@Repository
public class BigAppIpDaoImpl implements BigAppIpDao {


    @Autowired
    RedisTemplate redisTemplate;

    @Override
    public HttpProxy getBigIp(String channelId, String type) {
        List<String> lines = new ArrayList<>();

        try {
            Resource resource = new ClassPathResource("ips/goodip-2018-04-09.txt");
            BufferedReader br = null;
            br = new BufferedReader(new InputStreamReader(resource.getInputStream()));
            String temp = null;


            while ((temp = br.readLine()) != null) {

                lines.add(temp);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }


        HttpProxy proxy = null;
        if (lines != null && lines.size() > 0) {
            String line = lines.get(RandomUtil.randomInt(lines.size()));
            if (StringUtil.isNotBlank(line)) {

                proxy = new HttpProxy();
                proxy.setAddress(line.split(":")[0]);
                proxy.setPort(Integer.parseInt(line.split(":")[1]));
            }

        }

        return proxy;
    }

    @Override
    public HttpProxy getIp(String channelId, String type) {

        return getStaticIp();
    }

    @Override
    public void returnIp(String var1, String var2) {

    }


    /**
     * 获取静态ip
     *
     * @return
     */
    public HttpProxy getStaticIp() {
        List<String> lines = new ArrayList<>();

        try {
            Resource resource = new ClassPathResource("ips/ips.txt");
            BufferedReader br = null;
            br = new BufferedReader(new InputStreamReader(resource.getInputStream()));
            String temp = null;


            while ((temp = br.readLine()) != null) {

                lines.add(temp);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }


        HttpProxy proxy = null;
        if (lines != null && lines.size() > 0) {
            String line = lines.get(RandomUtil.randomInt(lines.size()));
            if (StringUtil.isNotBlank(line)) {

                proxy = new HttpProxy();
                proxy.setAddress(line.split(":")[0]);
                proxy.setPort(Integer.parseInt(line.split(":")[1]));
            }

        }

        return proxy;
    }


    public HttpProxy getRamdom() {

        Set<String> sets = redisTemplate.keys("ZHANDAYE_IP_*");
        if (sets != null && sets.size() > 0) {
            List<String> lists = CommonUtils.toList(sets);

            String  randomKey = lists.get(RandomUtil.randomInt(lists.size()));
            String value=  redisTemplate.opsForValue().get(randomKey).toString();
            String address = JsonUtils.get(value, "address");
            String port = JsonUtils.get(value, "port");
            HttpProxy proxy = new HttpProxy();
            proxy.setPort(Integer.parseInt(port));
            proxy.setAddress(address);
            return proxy;
        }

        return null;
    }
}
