package com.bjlt.spider.business.lionair.controller;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.business.lionair.service.LionairService;
import com.bjlt.spider.business.lionairthai.service.LionairthaiService;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.config.RedisService;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.entity.SourceEnum;
import com.bjlt.spider.util.RespEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.concurrent.ExecutorService;

@Controller
@Slf4j
@RequestMapping("/lionair/")
public class LionairController {

    @Autowired
    LionairService lionairService;

    @Autowired
    ExecutorService executorService;

    @Autowired
    RedisService redisService;

    @Autowired
    Config config;


    /**
     * 狮子查询接口
     * @author zhuyangxu
     * @param searchRequestEntity
     * @return
     */
    @RequestMapping(value = "/search", method = RequestMethod.POST)
    @ResponseBody
    public RespEntity search(@RequestBody SearchRequestEntity searchRequestEntity) {

        log.info("请求的数据为--->" + JSON.toJSONString(searchRequestEntity));
        try {
            RespEntity respEntity = lionairService.search(searchRequestEntity);
            log.info("返回的数据为--->" + JSON.toJSONString(respEntity));
            return respEntity;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return RespEntity.error("爬虫错误");
    }



    /**
     * 狮子验证程序
     * @author zhuyangxu
     * @param searchRequestEntity
     * @return
     */
    @RequestMapping(value = "/verify",method =  RequestMethod.POST)
    @ResponseBody
    public RespEntity verify(@RequestBody SearchRequestEntity searchRequestEntity) {
        try {
            int threadNum = 4;
            //如果是手机端查询进行一次查询 如果同一个ip 多次查询 手机端则会失败
            if(searchRequestEntity.getAirSource().equals(SourceEnum.LA_MOBILE.getSourceId()+"")){
                threadNum =1;
            }
            for (int i = 0; i < threadNum; i++) {
                executorService.execute(new Runnable() {
                    @Override
                    public void run() {
                        try {
                            log.info("存入的key为-->{}", config.getSearchKey());
                            redisService.sendChannelMess(config.getSearchKey(), JSON.toJSONString(searchRequestEntity));
                        } catch (Exception e) {
                        }
                    }
                });
            }
        } catch (Exception e) {

            return RespEntity.error("存入失败");
        }
        return RespEntity.error("存入成功");
    }
}
