package com.bjlt.spider.business.ryanair.controller;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.business.ryanair.service.RyanairWebService;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.util.RespEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * @author: luyanan0718@163.com
 * @create :2018/1/8 19:03
 * @introduce :
 **/

@Slf4j
@Controller
@RequestMapping("/ryanair/web/")
public class RyanairWebController {


    @Autowired
    RyanairWebService ryanairWebService;


    @RequestMapping(value = "/search", method = RequestMethod.POST)
    @ResponseBody
    public RespEntity search(@RequestBody SearchRequestEntity searchRequestEntity) {

        log.info("请求的参数为-->{}", JSON.toJSONString(searchRequestEntity));

        try {
            RespEntity respEntity = ryanairWebService.searchWeb(searchRequestEntity);
            if (respEntity.getStatus() == 200) {
                return respEntity;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return RespEntity.error("爬虫错误");
    }
}
