package com.bjlt.spider.business.ryanair.service.impl;

import com.bjlt.spider.airasia.dao.IpDao;
import com.bjlt.spider.business.common.dao.BigAppIpDao;
import com.bjlt.spider.business.ryanair.service.RyanairAPPService;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.ryanair.dao.RyanairAPPDao;
import com.bjlt.spider.ryanair.dao.RyanairWebDao;
import com.bjlt.spider.util.MethodType;
import com.bjlt.spider.util.RespEntity;
import com.luyn.core.StringUtil;
import com.luyn.http.proxy.HttpProxy;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author: luyanan0718@163.com
 * @create :2018/1/9 11:55
 * @introduce :
 **/

@Service
public class RyanairAPPServiceImpl implements RyanairAPPService {
    @Autowired
    RyanairAPPDao ryanairAppDao;

    @Autowired
    RyanairWebDao ryanairWebDao;

    @Autowired
    BigAppIpDao ipDao;

    @Autowired
    Config config;

    @Override
    public SearchResponseEntity searchAPP(SearchRequestEntity searchRequestEntity) {
        SearchResponseEntity searchResponseEntity = new SearchResponseEntity();
        searchResponseEntity.setFormCity(searchRequestEntity.getFormCity());

        searchResponseEntity.setRetDate(searchRequestEntity.getRetDate());
        searchResponseEntity.setFromDate(searchRequestEntity.getFromDate());
        searchResponseEntity.setToCity(searchRequestEntity.getToCity());
        searchResponseEntity.setTripType(searchRequestEntity.getTripType());
        searchResponseEntity.setChildNum(searchRequestEntity.getChildNum());
        searchResponseEntity.setAdultNum(searchRequestEntity.getAdultNum());
        searchResponseEntity.setUuid(searchRequestEntity.getUuid());
        searchResponseEntity.setQueneName(searchRequestEntity.getQueneName());
        searchResponseEntity.setSearchId(searchRequestEntity.getSearchId());






        try {


            HttpProxy proxy = null;
            if (config != null && config.isProxy()) {
                proxy = ipDao.getIp("RyanairAPP", MethodType.SEARCH.getTypeName());
            }
            RespEntity respEntity = ryanairAppDao.getAPPSearchContent(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity(), searchRequestEntity.getRetDate(), searchRequestEntity.getTripType(), searchRequestEntity.getAdultNum(), searchRequestEntity.getChildNum(), searchRequestEntity.getCurrency(), proxy);

            if (proxy != null && StringUtil.isNotBlank(proxy.getAddress())) {
                ipDao.returnIp("RyanairAPP", proxy.getAddress() + ":" + proxy.getPort());
            }
            if (respEntity.getStatus() == 200) {
                searchResponseEntity = ryanairWebDao.parserWebContent(respEntity.getAttachment().toString(), searchRequestEntity);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return searchResponseEntity;
    }
}
