package com.bjlt.spider.business.ryanair.service.impl;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.airasia.dao.IpDao;
import com.bjlt.spider.business.common.dao.BigAppIpDao;
import com.bjlt.spider.business.ryanair.service.RyanairWebService;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.ryanair.dao.RyanairWebDao;
import com.bjlt.spider.util.MethodType;
import com.bjlt.spider.util.RespEntity;
import com.luyn.core.StringUtil;
import com.luyn.http.proxy.HttpProxy;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author: luyanan0718@163.com
 * @create :2018/1/8 18:58
 * @introduce :
 **/

@Service
@Slf4j
public class RyanairWebServiceImpl implements RyanairWebService {

    @Autowired
    RyanairWebDao ryanairDao;

    @Autowired
    BigAppIpDao ipDao;

    @Autowired
    Config config;

    @Override
    public RespEntity searchWeb(SearchRequestEntity searchRequestEntity) {
        SearchResponseEntity searchResponseEntity = new SearchResponseEntity();


        try {
            HttpProxy proxy = null;
            if (config != null && config.isProxy()) {
                proxy = ipDao.getIp("Ryanair_Web", MethodType.SEARCH.getTypeName());
            }
            RespEntity respEntity = ryanairDao.getWebSearchContent(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity(), searchRequestEntity.getRetDate(), searchRequestEntity.getTripType(), searchRequestEntity.getAdultNum(), searchRequestEntity.getChildNum(), searchRequestEntity.getCurrency(), proxy);

            if (proxy != null && StringUtil.isNotBlank(proxy.getAddress())) {
                ipDao.returnIp("Ryanair_Web", proxy.getAddress());
            }


            if (respEntity.getStatus() == 200) {
                searchResponseEntity = ryanairDao.parserWebContent(respEntity.getAttachment().toString(), searchRequestEntity);
                searchResponseEntity.setFormCity(searchRequestEntity.getFormCity());
                searchResponseEntity.setRetDate(searchRequestEntity.getRetDate());
                searchResponseEntity.setFromDate(searchRequestEntity.getFromDate());
                searchResponseEntity.setToCity(searchRequestEntity.getToCity());
                searchResponseEntity.setTripType(searchRequestEntity.getTripType());
                searchResponseEntity.setChildNum(searchRequestEntity.getChildNum());
                searchResponseEntity.setAdultNum(searchRequestEntity.getAdultNum());
                searchResponseEntity.setUuid(searchRequestEntity.getUuid());
                searchResponseEntity.setQueneName(searchRequestEntity.getQueneName());
                searchResponseEntity.setSearchId(searchRequestEntity.getSearchId());
                searchResponseEntity.setAdultNum(searchRequestEntity.getAdultNum());
                searchResponseEntity.setChildNum(searchRequestEntity.getChildNum());
                log.info("返回的数据为-->{}", JSON.toJSONString(searchResponseEntity));
                return  RespEntity.success(searchResponseEntity);
            } else {
                return RespEntity.error(respEntity.getMessage());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return RespEntity.error("获取数据失败");
    }
}
