package com.bjlt.spider.business.vietjetair.service.impl;

import com.bjlt.spider.airasia.dao.IpDao;
import com.bjlt.spider.business.common.dao.BigAppIpDao;
import com.bjlt.spider.business.vietjetair.service.VietjetairAPPService;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.AirlineInfomation;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.entity.SourceEnum;
import com.bjlt.spider.util.MethodType;
import com.bjlt.spider.util.RespEntity;
import com.bjlt.spider.vietjetair.VietjetairAPPDao;
import com.bjlt.spider.vietjetair.VietjetairMobileDao;
import com.luyn.core.StringUtil;
import com.luyn.http.proxy.HttpProxy;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author: luyanan0718@163.com
 * @create :2018/2/1 19:18
 * @introduce :
 **/

@Service
public class VietjetairAPPServiceImpl implements VietjetairAPPService {


    @Autowired
    BigAppIpDao ipDao;

    @Autowired
    Config config;

    @Autowired
    VietjetairAPPDao vietjetairAPPDao;

    @Autowired
    VietjetairMobileDao vietjetairMobileDao;


    @Override
    public RespEntity search(SearchRequestEntity searchRequestEntity) {


        SearchResponseEntity searchResponseEntity = new SearchResponseEntity();
        searchResponseEntity.setFromDate(searchRequestEntity.getFromDate());
        searchResponseEntity.setFormCity(searchRequestEntity.getFormCity());
        searchResponseEntity.setToCity(searchRequestEntity.getToCity());
        searchResponseEntity.setRetDate(searchRequestEntity.getRetDate());
        searchResponseEntity.setUuid(searchRequestEntity.getUuid());
        searchResponseEntity.setQueneName(searchRequestEntity.getQueneName());
        searchResponseEntity.setSearchId(searchRequestEntity.getSearchId());
        searchResponseEntity.setAdultNum(searchRequestEntity.getAdultNum());
        searchResponseEntity.setChildNum(searchRequestEntity.getChildNum());
        searchRequestEntity.setActionId(searchRequestEntity.getActionId());

        try {
            // 进行 非空验证
            if (StringUtil.hasBlank(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity()) || searchRequestEntity.getAdultNum() <= 0) {
                return RespEntity.error("请求参数不正确");

            }
            if (StringUtil.isBlank(searchRequestEntity.getCurrency())) {
                searchRequestEntity.setCurrency("CNY");
            }
            HttpProxy proxy = null;
            if (config != null && config.isProxy()) {
                proxy = ipDao.getIp("vietject_APP", MethodType.SEARCH.getTypeName());
                if (proxy == null || StringUtil.isBlank(proxy.getAddress())) {
                    return RespEntity.error("获取ip 失败");
                }
            }
            List<AirlineInfomation> retSegments = new ArrayList<>();
            List<AirlineInfomation> fromSegments = new ArrayList<>();
            RespEntity fromSegmentsContentResp = vietjetairAPPDao.getFlightContent(searchRequestEntity.getFormCity(), searchRequestEntity.getFromDate(), searchRequestEntity.getToCity(), searchRequestEntity.getAdultNum(), searchRequestEntity.getChildNum(), searchRequestEntity.getCurrency(), "", proxy);
            if (fromSegmentsContentResp.getStatus() == 200) {
                System.out.println(fromSegmentsContentResp.getAttachment());
                 fromSegments = vietjetairMobileDao.flightContentParser(fromSegmentsContentResp.getAttachment().toString(), searchRequestEntity);
                if (fromSegments != null && fromSegments.size() > 0) {
                    for (AirlineInfomation fromSegment : fromSegments) {
                        fromSegment.setFormCity(searchRequestEntity.getFormCity());
                        fromSegment.setFromDate(searchRequestEntity.getFromDate());
                        fromSegment.setToCity(searchRequestEntity.getToCity());
                        fromSegment.setCurrency(searchRequestEntity.getCurrency());
                        fromSegment.setAirSourceName(searchRequestEntity.getAirSource());

                    }
                }

            }

            // 回程信息
            if (StringUtil.isNotBlank(searchRequestEntity.getRetDate())) {
                RespEntity retSegmentsContentResp = vietjetairAPPDao.getFlightContent(searchRequestEntity.getToCity(), searchRequestEntity.getRetDate(), searchRequestEntity.getFormCity(), searchRequestEntity.getAdultNum(), searchRequestEntity.getChildNum(), searchRequestEntity.getCurrency(), "", proxy);
                if (retSegmentsContentResp.getStatus() == 200) {
                     retSegments = vietjetairMobileDao.flightContentParser(retSegmentsContentResp.getAttachment().toString(), searchRequestEntity);
                    if (retSegments != null && retSegments.size() > 0) {
                        for (AirlineInfomation retSegment : retSegments) {
                            retSegment.setCurrency(searchRequestEntity.getCurrency());
                            retSegment.setFormCity(searchRequestEntity.getToCity());
                            retSegment.setFromDate(searchRequestEntity.getRetDate());
                            retSegment.setToCity(searchRequestEntity.getFormCity());
                            retSegment.setAirSourceName(searchRequestEntity.getAirSource());

                        }
                    }
                    searchResponseEntity.setRetSegments(retSegments);
                }
            }
            searchResponseEntity.setFromSegments(fromSegments);
            searchResponseEntity.setRetSegments(retSegments);
            searchResponseEntity.setActionId(searchRequestEntity.getActionId());
            if (proxy != null && StringUtil.isNotBlank(proxy.getAddress())) {
                ipDao.returnIp("vietject_APP", proxy.getAddress() + ":" + proxy.getPort());
            }
            return RespEntity.success(searchResponseEntity);
        } catch (Exception e) {
            e.printStackTrace();
        }


        return RespEntity.error("search 失败");
    }
}
