package com.bjlt.spider.business.vietjetair.utils;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.business.vietjetair.service.VietjetairAPPService;
import com.bjlt.spider.business.vietjetair.service.VietjetairMobileService;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.monitor.utils.CallBackUtils;
import com.bjlt.spider.util.RespEntity;
import com.luyn.core.RandomUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @author: luyanan0718@163.com
 * @create :2018/3/5 17:50
 * @introduce :
 **/

@Slf4j
public class VietjetairRandomRunnable implements Runnable {


    private VietjetairMobileService vietjetairMobileService;


    private VietjetairAPPService vietjetairAPPService;


    private Config config;


    private SearchRequestEntity searchRequestEntity;

    public VietjetairRandomRunnable(VietjetairMobileService vietjetairMobileService, VietjetairAPPService vietjetairAPPService, Config config, SearchRequestEntity searchRequestEntity) {
        this.vietjetairMobileService = vietjetairMobileService;
        this.vietjetairAPPService = vietjetairAPPService;
        this.config = config;
        this.searchRequestEntity = searchRequestEntity;
    }

    @Override
    public void run() {
        int random = RandomUtil.randomInt(5);

        if (random == 0 || random == 2 || random == 4) {
// 启用 mobile端查询
            log.info("越捷mobile端请求的参数为-->>{}", JSON.toJSONString(searchRequestEntity));

            try {
                RespEntity respEntity = vietjetairMobileService.search(searchRequestEntity);
                if (respEntity != null && respEntity.getStatus() == 200) {
                    CallBackUtils.callBack(JSON.toJSONString(respEntity), config);
                } else {
                    log.info("越捷mobile端请求失败，切换为app端");
                    respEntity = vietjetairAPPService.search(searchRequestEntity);
                    if (respEntity != null && respEntity.getStatus() == 200) {
                        CallBackUtils.callBack(JSON.toJSONString(respEntity), config);
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {

            log.info("越捷app端请求的参数为-->>{}", JSON.toJSONString(searchRequestEntity));


            try {
                RespEntity respEntity = vietjetairAPPService.search(searchRequestEntity);
                if (respEntity != null && respEntity.getStatus() == 200) {
                    CallBackUtils.callBack(JSON.toJSONString(respEntity), config);
                } else {
                    log.info("越捷app端请求失败，切换为mobile端");
                    respEntity = vietjetairMobileService.search(searchRequestEntity);
                    if (respEntity != null && respEntity.getStatus() == 200) {
                        CallBackUtils.callBack(JSON.toJSONString(respEntity), config);
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }

        }
    }
}
