package com.bjlt.spider.config;

import com.luyn.core.RandomUtil;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.UUID;

/**
 * @author: luyanan0718@163.com
 * @create :2018/1/10 10:16
 * @introduce :  一些全局的配置
 **/

@Component
public class Config {


    /**
     * 是否开启代理ip
     */
    @Value("${isProxy}")
    private boolean proxy;


    /**
     * 查询分类
     *
     * @return
     */
    @Value("${search_type}")
    private Integer searchType;


    /**
     * 回调地址主域名
     */
    @Value("${call_back_host}")
    private String callBackHost;


    @Value("${searchKey}")
    private String searchKey;


    @Value("${spidermonitor}")
    private String spidermonitorUrl;


    /**
     * 程序端口
     */
    @Value("${server.port}")
    private int port;


    /**
     * 程序名称
     */
    @Value("${spring.application.name}")
    private String projectName;


    public String getSpidermonitorUrl() {
        return spidermonitorUrl;
    }

    public void setSpidermonitorUrl(String spidermonitorUrl) {
        this.spidermonitorUrl = spidermonitorUrl;
    }

    public int getPort() {
        return port;
    }

    public void setPort(int port) {
        this.port = port;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getSearchKey() {
        return searchKey;
    }

    public void setSearchKey(String searchKey) {
        this.searchKey = searchKey;
    }

    public Integer getSearchType() {
        return searchType;
    }

    public void setSearchType(Integer searchType) {
        this.searchType = searchType;
    }

    public String getCallBackHost() {
        return callBackHost;
    }

    public void setCallBackHost(String callBackHost) {
        this.callBackHost = callBackHost;
    }

    public boolean isProxy() {
        return proxy;
    }

    public void setProxy(boolean proxy) {
        this.proxy = proxy;
    }


}
