package com.bjlt.spider.config;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.business.AirChooseUtils;
import com.bjlt.spider.business.Jinair.service.JinairService;
import com.bjlt.spider.business.airasia.service.AirAsiaWebService;
import com.bjlt.spider.business.lionair.service.LionairService;
import com.bjlt.spider.business.lionairthai.service.LionairthaiService;
import com.bjlt.spider.business.vietjetair.service.VietjetairAPPService;
import com.bjlt.spider.business.vietjetair.service.VietjetairMobileService;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.entity.SourceEnum;
import com.bjlt.spider.entity.monitor.MonitorEntity;
import com.bjlt.spider.monitor.utils.CallBackUtils;
import com.bjlt.spider.monitor.utils.SearchStatisticsUtil;
import com.bjlt.spider.util.MethodType;
import com.bjlt.spider.util.RespEntity;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.luyn.core.RandomUtil;
import com.luyn.core.StringUtil;
import com.luyn.log.SysLogger;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.Date;
import java.util.concurrent.ExecutorService;


/**
 * @author: luyanan0718@163.com
 * @create :2018/3/6 18:01
 * @introduce : redis 的订阅者
 **/

@Service
@Slf4j
public class RedisReceiver {

    private static final SysLogger logger = SysLogger.getSysLogger(RedisReceiver.class);


    @Autowired
    private ExecutorService executorService;


    @Autowired
    Config config;

    @Autowired
    AirChooseUtils airChooseUtils;

    private ObjectMapper objectMapper = new ObjectMapper();

    public void receiveMessage(String message) {
        //这里是收到通道的消息之后执行的方法
        executorService.execute(new Runnable() {
            @Override
            public void run() {

                SearchStatisticsUtil.SearchTotal();//统计请求次数
                MonitorEntity monitorEntity = new MonitorEntity();
                log.info(java.lang.Thread.currentThread().getName() + "---" + java.lang.Thread.currentThread().getId());
                try {
                    SearchRequestEntity searchRequestEntity = objectMapper.readValue(message, SearchRequestEntity.class);
                    monitorEntity.setRequestType(MethodType.SEARCH.getTypeName());
                    monitorEntity.setQuestEntity(searchRequestEntity);
                    monitorEntity.setRequestDate(new Date());
                    RespEntity respEntity = airChooseUtils.workers(searchRequestEntity);
                    CallBackUtils.callBack(JSON.toJSONString(respEntity),config);
                    logger.info(SysLogger.builder().logFilePath("syslog/monitor").isCreateFile(true).name("monitor").message(monitorEntity).build());
                } catch (IOException e) {
                    e.printStackTrace();
                }

            }
        });


    }

}