package com.bjlt.spider.config;

import com.google.common.util.concurrent.ThreadFactoryBuilder;
import com.luyn.core.ThreadPoolUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import java.util.Set;
import java.util.concurrent.*;

/**
 * @author: luyanan0718@163.com
 * @create :2018/3/5 17:36
 * @introduce :
 **/

@Component
public class ThreadPool {
    static ThreadFactory factory = new ThreadFactoryBuilder().setNameFormat("search-pool-%d").build();

    @Bean
    public ExecutorService executorService() {


        return new ThreadPoolExecutor(10, 30, 30L, TimeUnit.SECONDS, new LinkedBlockingDeque<>(1024), factory, new ThreadPoolExecutor.DiscardPolicy());
    }


}
