package com.bjlt.spider.index;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.business.AirChooseUtils;
import com.bjlt.spider.business.airasia.service.AirAsiaWebService;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.config.RedisReceiver;
import com.bjlt.spider.config.RedisService;
import com.bjlt.spider.entity.SearchRequestEntity;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.entity.monitor.MonitorEntity;
import com.bjlt.spider.monitor.utils.CallBackUtils;
import com.bjlt.spider.util.RespEntity;
import com.luyn.core.StringUtil;
import com.luyn.json.JsonUtils;
import com.luyn.log.SysLogger;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Date;
import java.util.concurrent.ExecutorService;

/**
 * @author: luyanan0718@163.com
 * @create :2018/4/8 10:32
 * @introduce :  欢迎controller
 **/

@Controller
@Slf4j
public class indexController {

    @Autowired
    Config config;


    @Autowired
    RedisService redisService;


    @Autowired
    ExecutorService executorService;

    @Autowired
    AirChooseUtils airChooseUtils;


    /**
     * 航司数据查询
     *
     * @param searchRequestEntity
     * @return
     */
    @RequestMapping(value = "search", method = RequestMethod.POST)
    @ResponseBody
    public RespEntity search(@RequestBody SearchRequestEntity searchRequestEntity) {

        log.info("开始查询，查询参数为-->{}", JSON.toJSONString(searchRequestEntity));
        try {
            redisService.sendChannelMess(config.getSearchKey(), JSON.toJSONString(searchRequestEntity));
        } catch (Exception e) {
            e.printStackTrace();
            return RespEntity.error("数据存入失败");
        }
        return RespEntity.success("数据存入成功");
    }


    /**
     * 直接获取结果
     *
     * @param searchRequestEntity
     * @return
     */
    @RequestMapping(value = "testsearch", method = RequestMethod.POST)
    @ResponseBody
    public RespEntity testSearch(@RequestBody SearchRequestEntity searchRequestEntity) {

        return airChooseUtils.workers(searchRequestEntity);

    }


    /**
     * 验证
     *
     * @param searchRequestEntity
     * @return
     */
    @RequestMapping(value = "verify", method = RequestMethod.POST)
    @ResponseBody
    public RespEntity verify(@RequestBody SearchRequestEntity searchRequestEntity) {
        try {
            for (int i = 0; i < 4; i++) {
                executorService.execute(new Runnable() {
                    @Override
                    public void run() {
                        // 存入redis中


                        try {
                            log.info("存入的key为-->{}", config.getSearchKey());
                            redisService.sendChannelMess(config.getSearchKey(), JSON.toJSONString(searchRequestEntity));

                            //                       return RespEntity.success("存入成功");
                        } catch (Exception e) {
                            //                       return RespEntity.error("存入失败");
                        }
                    }
                });
            }
        } catch (Exception e) {

            return RespEntity.error("存入失败");
        }


        return RespEntity.error("存入成功");

    }


}
