package com.bjlt.spider.monitor.dao.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.monitor.dao.MonitorDao;
import com.bjlt.spider.monitor.utils.SearchStatisticsUtil;
import com.bjlt.spider.util.RespEntity;
import com.luyn.date.DatePattren;
import com.luyn.date.DateUtil;
import com.luyn.http.httpclient.HttpClientDownloader;
import com.luyn.http.okhttp.OkHttpDownLoader;
import com.luyn.json.JsonUtils;
import com.luyn.servlet.IpUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * @author: luyanan0718@163.com
 * @create :2018/3/22 14:07
 * @introduce :
 **/

@Repository
@Slf4j
public class MonitorDaoImpl implements MonitorDao {


    @Autowired
    Config config;


    @Override
    public RespEntity sendStatisticsInfo() {

        try {
            Map<String, String> map = new HashMap<>();
            String intranetIp = JSON.toJSONString(IpUtils.getIntranetIp());


            JSONObject jsonObject = SearchStatisticsUtil.getSearchStatistics();

            String totalNum = jsonObject.get("totalNum").toString();
            String errorNum = jsonObject.get("errorNum").toString();
            String successNum = jsonObject.get("successNum").toString();
            String noData = jsonObject.get("noData").toString();


            // 内网ip
            map.put("intranetIp", intranetIp);
            // 外网ip
            map.put("extranet", "");
            // 程序名称
            map.put("projectName", config.getProjectName());
            // 端口
            map.put("port", config.getPort() + "");
            // 请求总数
            map.put("totalNum", totalNum);
            //  成功数并且有数据
            map.put("successUm", successNum);
            // 不出错，无数据
            map.put("noData", noData);

            // 请求出错总数
            map.put("errorNum", errorNum);

            String  countTime = DateUtil.getFormatDate(new Date(), DatePattren.TIME_FORMAT_MILLI);
            map.put("countTime",countTime);
            log.info("发送统计信息--->{}", JSON.toJSONString(map));
            try {
                HttpClientDownloader.post(config.getSpidermonitorUrl()).connectTimeout(500, TimeUnit.MINUTES).readTimeout(500,TimeUnit.MINUTES).json(map).HttpClientexecute();
            } catch (Exception e) {
                HttpClientDownloader.post(config.getSpidermonitorUrl()).connectTimeout(500, TimeUnit.MINUTES).readTimeout(500,TimeUnit.MINUTES).json(map).HttpClientexecute();
                e.printStackTrace();
            }
        } catch (Exception e) {

            e.printStackTrace();
            return  RespEntity.error("发送统计失败");
        }


        return  RespEntity.error("发送统计成功");
    }


}
