package com.bjlt.spider.monitor.utils;

import com.alibaba.fastjson.JSON;
import com.bjlt.spider.config.Config;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.luyn.http.okhttp.OkHttpDownLoader;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @author: luyanan0718@163.com
 * @create :2018/2/6 10:17
 * @introduce : 回调函数
 **/

@Slf4j
public class CallBackUtils {
//
//
//    @Autowired
//    Config config;
    /**
     * 回调
     *
     * @param json
     * @param config
     */
    public static void callBack(String json, Config config) {

        log.info("开始回调");


        try {
            if (config != null) {
                String url = config.getCallBackHost();
                int code = 0;
                // 调用普通回调
                if (config.getSearchType() == 0) {

                    url = url + "/receive/receiveSearch";
                    code = OkHttpDownLoader.textBody(url).json(json).okhttpexecute().getHttpCode().getHttpCode();
//                    if (code == 200) {
                    log.info("{}回调成功,回调参数为--{}", url, json);
//                    }
                } else {
                    // 调用 vop回调
                    url = url + "/receive/receiveVop";
                    code = OkHttpDownLoader.textBody(url).json(json).okhttpexecute().getHttpCode().getHttpCode();
//                    if (code == 200) {
                    log.info("{}回调成功,回调参数为--{}", url, json);
//                    }

                }

//                log.info("回调成功");

            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        log.info("回调成功");

    }

//    /**
//     * 查询结果回调Dubbo方式
//     * @param searchResponseEntity
//     * @param uuid
//     */
//    public static void callBack(SearchResponseEntity searchResponseEntity,String uuid) {
////        Integer callbackPass = Integer.parseInt(uuid);
//        try {
//         CallBackUtils.callBack(JSON.toJSONString(searchResponseEntity),uuid);
//            log.info("回调成功");
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("回调出错："+e);
//        }
//
//    }


}
