package com.bjlt.spider.monitor.utils;

import com.alibaba.fastjson.JSONObject;
import com.luyn.date.DatePattren;
import com.luyn.date.DateUtil;

import java.util.Date;

/**
 * 统计查询成功率
 */
public class SearchStatisticsUtil {

    private static int totalNum;//查询总数统计
    private static int errorNum = 0;//出错数
    private static int successNum = 0;//成功数并且有数据
    private static int noData = 0;//不出错，无数据
    private static String lastDatetime = "";//上一次获取时间

    /**
     * 统计查询成功数
     */
    public static void SearchTotal() {
        totalNum++;
    }

    /**
     * 统计查询成功数
     */
    public static void SearchError() {
        errorNum++;
    }

    /**
     * 统计查询失败数
     */
    public static void SearchSuccess() {
        successNum++;
    }

    /**
     * 统计查询成功无数据个数
     */
    public static void SearchNoData() {
        noData++;
    }

    /**
     * 获取统计数据，并且清空
     *
     * @return
     */
    public static JSONObject getSearchStatistics() {
        JSONObject json = new JSONObject();
        json.put("totalNum", totalNum);
        json.put("errorNum", errorNum);
        json.put("successNum", successNum);
        json.put("noData", noData);
        json.put("lastDatetime", lastDatetime);//上一次获取统计数据时间
        json.put("currentDatetime", DateUtil.getFormatDate(new Date(), DatePattren.TIME_FORMAT));//当前时间
        lastDatetime = DateUtil.getFormatDate(new Date(), DatePattren.TIME_FORMAT);
        errorNum = 0;//出错数
        successNum = 0;//成功数并且有数据
        noData = 0;//不出错，无数据
        totalNum =0;
        return json;
    }


}
