package com.bjlt.spider.utils;

import com.luyn.http.utils.CookieUtils;
import com.luyn.io.FileUtil;
import com.luyn.io.IoUtil;
import org.apache.http.*;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.BasicCredentialsProvider;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.impl.conn.DefaultProxyRoutePlanner;
import org.apache.http.util.EntityUtils;


import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

/**
 * 慧聪专用HTTP网络请求工具
 *
 * @Description:TODO
 * @author: ZhangQifei
 * @time:2017年6月15日 下午1:44:20
 */
public class ParityHttpUtil {

	//请求超时时间  毫秒
	public static int SocketTimeout = 1000 * 30;
	//响应超时时间 毫秒 
	public static int ConnectTimeout = 1000 * 30;
	//字符编码  UTF-8
	public static String UTF_code = "utf-8";
	//GB2312
	public static String GB_code = "GB2312";
	//------代理设置    默认------
	//设置用户名     "HC43V6QHT0021R6D";
	public static String ProxyUser = "HC43V6QHT0021R6D";
	//密码   "2D7B2BB04808B769"
	public static String ProxyPass = "2D7B2BB04808B769";
	// 用户名：密码（base64的编码）
	public static String Basic = "SEM0M1Y2UUhUMDAyMVI2RDoyRDdCMkJCMDQ4MDhCNzY5";
	// 设置域名：默认         阿布云 （proxy.abuyun.com）
	public static String HostName = "proxy.abuyun.com";
	// 设置端口号  默认      port 9020
	public static int Port = 9020;

	public static void main(String[] args) {
		Map<String,String> headerMap = new HashMap<>();
		headerMap.put("accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8");
		headerMap.put("accept-encoding", "gzip,deflate, br");
		headerMap.put("accept-language", "zh-CN,zh;q=0.8");
//			headerMap.put("referer", "https://www.airasia.com/cn/zh/home.page?utm_medium=cpc&utm_source=baidu&utm_campaign=zone&utm_content=title");
		headerMap.put("user-agent", "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.100 Safari/537.36");
		Map<String,String>   result  = getUrl("https://www.airasia.com/cn/zh/home.page?cid=1",headerMap);
		System.out.println("___"+result.get("setCookie"));
		String url = "https://booking.airasia.com/Flight/Select?o1=MFM&d1=DPS&culture=zh-CN&dd1=2017-12-25&ADT=1&s=true&mon=true&cc=CNY&c=false";
//
		Map<String,String> headers = new HashMap<>();
//		Map<String,String> html = getUrl(url,headers); //阿布云代理
//		System.out.println(html.get("html"));
		String html = getHtmlIpPort(url);
		System.out.println(html);
//		String url = "https://booking.airasia.com/Flight/Select?o1=MFM&d1=DPS&culture=zh-CN&dd1=2017-12-25&ADT=1&s=true&mon=true&cc=CNY&c=false";
//
//		Map<String,String> headers = new HashMap<>();
//		Map<String,String> html = getUrl(url,headers); //阿布云代理
//		//String html = getHtmlIpPort(url);
//		if (html.length() < 10000) System.out.println(html);
//
//		System.out.println(html.length());
//		if (html.length() > 100) {
//			Document document = Jsoup.parse(html);
//			Elements radioMarkets = document.select("input.square-radio.radio-markets");
//			for (Element radioMarket : radioMarkets) {
//				//String id = radioMarket.attr("id");
//				// String name = radioMarket.attr("name");
//				//String value = radioMarket.attr("value");
//				String dataJson = radioMarket.attr("data-json");
//				//String curreny = radioMarket.attr("data-cur");
//				System.out.println(dataJson);
//			}
//		}
	}


	public static Map<String, String> getUrl(String url, Map<String, String> headers) {
		try {
			return get(url, HostName, Port, UTF_code, SocketTimeout, ConnectTimeout, ProxyUser, ProxyPass, Basic, headers);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * GET请求，有代理
	 *
	 * @param url      请求地址
	 * @param hostname 代理地址
	 * @param port     端口
	 * @return
	 */
	@SuppressWarnings("deprecation")
	public static Map<String, String> get(String url, String hostname, int port, String code, int socketTimeout, int connectTimeout, String proxyUser, String proxyPass, String basic, Map<String, String> headers) throws Exception {
		CredentialsProvider credsProvider = new BasicCredentialsProvider();
		credsProvider.setCredentials(AuthScope.ANY, new UsernamePasswordCredentials(proxyUser, proxyPass));
		HttpHost proxy = new HttpHost(hostname, port);
		DefaultProxyRoutePlanner routePlanner = new DefaultProxyRoutePlanner(proxy);
		CloseableHttpClient httpClient = HttpClients.custom().setRoutePlanner(routePlanner).setDefaultCredentialsProvider(credsProvider).build();

		HttpGet httpGet = new HttpGet(url);
		//连接超时时间，10秒, 传输超时时间，30秒，不设置超时的话，一旦服务器没有响应，等待时间N久(>24小时)。
		RequestConfig requestConfig = RequestConfig.custom().setSocketTimeout(socketTimeout).setConnectTimeout(connectTimeout).build();

		httpGet.setConfig(requestConfig);// 设置请求器的配置
		httpGet.setHeader("Proxy-Switch-Ip", "yes");
		httpGet.setHeader("Accept-Encoding", "gzip, deflate");
		httpGet.setHeader("Proxy-Authorization", "Basic " + basic);

		if (headers != null && headers.size() > 0) {
			for (Map.Entry<String, String> entry : headers.entrySet()) {
				httpGet.setHeader(entry.getKey(), entry.getValue());
			}
		}

		Map<String, String> result = new HashMap<>();


//		httpGet.setHeader("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8");
//		httpGet.setHeader("Accept-Language", "zh-CN,zh;q=0.8,en-US;q=0.5,en;q=0.3");
//		httpGet.setHeader("Connection", "keep-alive");
//		httpGet.setHeader("Upgrade-Insecure-Requests", "1");
//		httpGet.setHeader("User-Agent", "Mozilla/5.0 (Windows NT 10.0; WOW64; rv:54.0) Gecko/20100101 Firefox/54.0");
//		httpGet.setHeader("Accept-Encoding", "GZIP");
//		httpGet.setHeader("referer", "https://mobile.airasia.com/index.php?SearchType=1");

		//httpGet.setHeader("cookie", "system:countryCode=CN; __gads=ID=cdb8412ebde10435:T=1510562255:S=ALNI_MbO-hnrRn-s9j_QUKeL-fR50M-bQA; flightSearch:DestinationStation=MEL; flightSearch%3AValuePackVege%3ADepart=1; acw_tc=AQAAAOwdwV0cMw0A/SN0e/vl8zJDGckh; AWSELB=FFAD03970AB0C84334F42B8DFA46245CC4FCA4B5C78C68AFAC78709A834873F287DE189D3517D7C033E20238A648F4B67569638B8CF8BC45845DD43EEDBA4CD7D24E7B26EF; flightSearch%3AAdultPax=1; flightSearch%3AKidsPax=0; flightSearch%3AInfantPax=0; acw_sc=5a097e9b0413b251472014b14e76b2092f11afe2; sessionToExpired=9pCEp4%2BouIc%3D%7Cl1%2BQcG00TIzkQRHvCLo8ksT4bhfciGKaP1k%2Bu%2F5kpNpPwqbb7pcMWet0tR0kLnmHL8znDo9IoKT16khfhyviZv5kMxPwTZKzzEi9dB2kgxpbEmdelVpIhmkolOCfGEDB0tWyY1dSqTm6Z4m1kYJzbA%3D%3D; flightSearch:Currency=CNY; flightSearch:DepartCountryCode=CN; flightSearch:ArrivalCountryCode=AU; flightSearch%3ADepartDate=2017-11-15; flightSearch%3AReturnDate=2017-11-18; flightSearch%3AJourneyDisplay=a%3A1%3A%7Bi%3A0%3Ba%3A3%3A%7Bi%3A0%3Bs%3A3%3A%22PEK%22%3Bi%3A1%3Bs%3A3%3A%22KUL%22%3Bi%3A2%3Bs%3A3%3A%22MEL%22%3B%7D%7D; appID=M001; M=0; P=E; C=N; A=U; system:currency=CNY; system:language=zh-CN; PHPSESSID=73280a8en2b4t13r98n245o2lgr8m4u39h0conk79feb3opc8rl1; flightSearch:SearchType=1; flightSearch:OriginStation=PEK; _booking_timings={\"searchFlight\":1510571715650,\"selectFlight\":1510571708247}; _hp2_ses_props.3785637731=%7B%22ts%22%3A1510571656160%2C%22d%22%3A%22mobile.airasia.com%22%2C%22h%22%3A%22%2Findex.php%22%7D; _hp2_id.3785637731=%7B%22userId%22%3A%222082820318316761%22%2C%22pageviewId%22%3A%225996990462709302%22%2C%22sessionId%22%3A%223628093607731857%22%2C%22identity%22%3Anull%2C%22trackerVersion%22%3A%223.0%22%7D; _dc_gtm_UA-8932346-16=1; __airasiaga=GA1.2.1732227349.1510562213; __airasiaga_gid=GA1.2.1589346363.1510562213; _gat_UA-8932346-16=1; _gali=search_next");

		HttpResponse response = httpClient.execute(httpGet);//执行请求Http
		StringBuffer setCookie = new StringBuffer();
		Header[] responseheaders = response.getAllHeaders();

		if (responseheaders != null && responseheaders.length > 0) {
			for (Header header : responseheaders) {
//				System.out.println(header.getName());
				if (header.getName().toLowerCase().equals("set-cookie")) {
					setCookie.append(CookieUtils.clearCookie(header.getValue())).append(";");
				}
			}
		}
		result.put("setCookie", setCookie.toString());
		HttpEntity entity = response.getEntity();
		String content = null;
		if (entity != null) {
//			String content = EntityUtils.toString(entity, code);
			InputStream is = null;
			try {
				is = entity.getContent();
				byte[] contentByte = IoUtil.toByteFromInputStream(is);
				content = new String(contentByte);
			} catch (IOException e) {
				e.printStackTrace();
			} catch (UnsupportedOperationException e) {
				e.printStackTrace();
			}
			result.put("html", content);
			System.out.println("html=----"+content.length());
			FileUtil.writeFile("D:/yahang.csv",content,"utf-8",false);
			if(is != null){
				is.close();
			}
			return result;
		}
		return result;
	}

	public static String getHtmlIpPort(String url) {
		try {
			HttpHost proxy = new HttpHost("	153.149.158.115", 3128);
			DefaultProxyRoutePlanner routePlanner = new DefaultProxyRoutePlanner(proxy);
			CloseableHttpClient httpClient = HttpClients.custom().setRoutePlanner(routePlanner).build();
			// 连接超时时间，10秒, 传输超时时间，30秒，不设置超时的话，一旦服务器没有响应，等待时间N久(>24小时)。
			HttpGet httpGet = new HttpGet(url);
			RequestConfig requestConfig = RequestConfig.custom().setSocketTimeout(30000).setConnectTimeout(30000).build();
			httpGet.setConfig(requestConfig);// 设置请求器的配置
			httpGet.addHeader(HttpHeaders.ACCEPT, "application/xml");
			HttpResponse response = httpClient.execute(httpGet);    //执行请求Http
			HttpEntity entity = response.getEntity();
			if (entity != null) {
				String content = EntityUtils.toString(entity, "GB2312");
				return content;
			}
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return "";
	}

}
